;===============================================================
; GET MAIN GAME DIRECTORY FROM EXE'S FULL PATH
;===============================================================

	mov ecx,[trespassexepathlength]
	xor edx,edx

	.findmaintrespathloop:

	cmp BYTE [trespassexepath_const+ecx],'\'
	jz .findmaintrespathloopend

	loop .findmaintrespathloop

	or edx,1
	or ecx,0FFFFFFFFh

	.findmaintrespathloopend:

	WRITELOG _message12,edx


;===============================================================
; SAVE MAIN GAME DIRECTORY
;===============================================================

	inc ecx
	mov esi,trespassexepath_const
	mov edi,gamedirpath_const
	mov [gamedirpathlength],ecx			; will point to null-terminator
	mov edx,ecx
	rep movsb
	mov BYTE [edi],0				; set null-terminator to Tres path after '\'

	mov ecx,edx
	mov esi,gamedirpath_const
	mov edi,gamedirpath
	rep movsb


;===============================================================
; COPY ROOT TRESPASSER PATH AND APPEND 'MAPS' FOLDER
;===============================================================

	mov esi,gamedirpath_const
	mov edi,mapsdirpath_const
	mov ecx,edx
	rep movsb					; move dir path to new location

	mov esi,MAPS_FOLDER_NAME
	call TransferString
	mov WORD [edi],'\'				; (include null-terminator)

	lea edx,[edi+1]
	sub edx,mapsdirpath_const

	mov ecx,edx
	mov [mapsdirpathlength],edx			; store size

	mov esi,mapsdirpath_const
	mov edi,mapsdirpath
	rep movsb


;===============================================================
; COPY ROOT TRESPASSER PATH AND APPEND 'ATX_LOGFILE.txt' (PREVIOUSLY FILENAME ONLY)
;===============================================================

	mov ecx,[gamedirpathlength]
	mov esi,gamedirpath_const
	mov edi,atxlogfilepath_const
	rep movsb

	mov esi,ATX_LOGFILE_NAME
	call TransferString


;===============================================================
; DDF FILE DIRECTORY VARIABLE
;===============================================================

	mov esi,mapsdirpath_const
	mov edi,ddfaltpath
	call TransferString


;===============================================================
; ATXCONFIG.INI PATH
;===============================================================

	mov esi,gamedirpath_const
	mov edi,atxconfigpath_const
	mov ecx,[gamedirpathlength]
	rep movsb

	mov esi,ATXCONFIG_FILENAME
	call TransferString
