;============================================================
ATXPROC DisplayTempMessage
;============================================================
; displays temporary message (5 seconds)

	GETDDSURFACEDC
	mov ebx,stack_ext_buffer

	cinvoke sprintf,ebx,[TempMessageString],[TempMessageParam1],\
			[TempMessageParam2],[TempMessageParam3],[TempMessageParam4]
							; params will only be used by function if used in string

	invoke TextOut,edi,0,SHOW_TEMP_MSG,ebx,eax

	RELEASEDDSURFACEDC

	invoke GetTickCount
	sub eax,[TempMessageTime]
	cmp eax,TEMP_MESSAGE_DISPLAY_INTERVAL
	    jb @f

		mov [TempMessageTime],0

	@@:

ret

;============================================================
ATXPROC DisplayErrorCount
;============================================================
; in-game error logging

cmp [RTErrorCount],0
    jz .exit

push ebp
mov ebp,esp
sub esp,100

	GETDDSURFACEDC

	lea ebx,[ebp-100]

	cinvoke sprintf,ebx,ERROR_COUNT_DISPLAY_STR,[RTErrorCount]

	invoke TextOut,edi,0,ERROR_LOG_MSG_VERT,ebx,eax

	RELEASEDDSURFACEDC

	invoke GetTickCount
	sub eax,[LastErrorTime]
	cmp eax,4000
	    jb @f

		mov [LastErrorTime],0

	@@:

mov esp,ebp
pop ebp
.exit:
ret
