;===============================================================
ATXPROC ModifyCAnimalSleepWakeUp	; adds Sleep and WakeUp values to all dinos
;===============================================================
push edi

	mov edi,[CAnimalBuffer]
	test edi,edi
	     jz .nomod

	.modonceonlyloop:
	mov eax,[edi+CANIMAL_INFO.Instance]

; add to instance's Sleep/WakeUp values (not updated after level restart)

	mov edx,[eax+CAnimal.lpCBrain]

; add to WakeUp

	fld DWORD [edx+CBrain.WakeUp]
	fadd [UseSleepWake]
	fstp DWORD [edx+CBrain.WakeUp]

; add to Sleep

	fld DWORD [edx+CBrain.Sleep]
	fadd [UseSleepWake]
	fstp DWORD [edx+CBrain.Sleep]

	add edi,sizeof.CANIMAL_INFO
	cmp edi,[CAnimalBufferEnd]
	    jb .modonceonlyloop

.nomod:
pop edi
ret

