;========================================================
; CANIMAL cheat data
;========================================================
align 4

CAnimalDisplayIndex		dd	0
CAnimalDisplayInfo		db	0
CAnimalTitleSize		dd	0
CAnimalTitleBuffer		db	64 dup 0

align 4



CAnimalObjValLocInfoTable:
OBJVALLOCINFO	InstanceName,	1,	0,			ATXVALTYPE_STRING,	0,					\
		BaseAddress,	1,	"Base Address", 	ATXVALTYPE_ADDRESSIMM,	0,					\
		NameHash,	1,	"Name Hash (CRC32)",	ATXVALTYPE_ADDRESS,	0,					\
		Location,	1,	"Location",		ATXVALTYPE_VECTOR,	0,					\
		HitPoints,	1,	"HitPoints",		ATXVALTYPE_FLOAT32,	0,					\
		MaxHitPoints,	1,	"MaxHitPoints", 	ATXVALTYPE_FLOAT32,	0,					\
		ActJumpNewInfo, 0,	"ActJumpNew info",	ATXVALTYPE_NONSTANDARD, ActJumpNewFormatCurrentAnimalInfo,	\
		Sleep,		0,	"Sleep",		ATXVALTYPE_FLOAT32,	0,					\
		WakeUp, 	0,	"WakeUp",		ATXVALTYPE_FLOAT32,	0,					\
		Bravery,	0,	"Bravery",		ATXVALTYPE_FLOAT32,	0,					\
		Fear,		0,	"Fear", 		ATXVALTYPE_FLOAT32,	0,					\
		Love,		0,	"Love", 		ATXVALTYPE_FLOAT32,	0,					\
		Anger,		0,	"Anger",		ATXVALTYPE_FLOAT32,	0,					\
		Curiosity,	0,	"Curiosity",		ATXVALTYPE_FLOAT32,	0,					\
		Hunger, 	0,	"Hunger",		ATXVALTYPE_FLOAT32,	0,					\
		Thirst, 	0,	"Thirst",		ATXVALTYPE_FLOAT32,	0,					\
		Fatigue,	0,	"Fatigue",		ATXVALTYPE_FLOAT32,	0,					\
		Pain,		0,	"Pain", 		ATXVALTYPE_FLOAT32,	0,					\
		Solidity,	0,	"Solidity",		ATXVALTYPE_FLOAT32,	0,					\
		HumanFear,	0,	"HumanFear",		ATXVALTYPE_FLOAT32,	0,					\
		HumanLove,	0,	"HumanLove",		ATXVALTYPE_FLOAT32,	0,					\
		HumanAnger,	0,	"HumanAnger",		ATXVALTYPE_FLOAT32,	0,					\
		HumanCuriosity, 0,	"HumanCuriosity",	ATXVALTYPE_FLOAT32,	0,					\
		HumanHunger,	0,	"HumanHunger",		ATXVALTYPE_FLOAT32,	0,					\
		HumanThirst,	0,	"HumanThirst",		ATXVALTYPE_FLOAT32,	0,					\
		HumanFatigue,	0,	"HumanFatigue", 	ATXVALTYPE_FLOAT32,	0,					\
		HumanPain,	0,	"HumanPain",		ATXVALTYPE_FLOAT32,	0,					\
		HumanSolidity,	0,	"HumanSolidity",	ATXVALTYPE_FLOAT32,	0,					\
		DamageFear,	0,	"DamageFear",		ATXVALTYPE_FLOAT32,	0,					\
		DamageLove,	0,	"DamageLove",		ATXVALTYPE_FLOAT32,	0,					\
		DamageAnger,	0,	"DamageAnger",		ATXVALTYPE_FLOAT32,	0,					\
		DamageCuriosity,0,	"DamageCuriosity",	ATXVALTYPE_FLOAT32,	0,					\
		DamageHunger,	0,	"DamageHunger", 	ATXVALTYPE_FLOAT32,	0,					\
		DamageThirst,	0,	"DamageThirst", 	ATXVALTYPE_FLOAT32,	0,					\
		DamageFatigue,	0,	"DamageFatigue",	ATXVALTYPE_FLOAT32,	0,					\
		DamagePain,	0,	"DamagePain",		ATXVALTYPE_FLOAT32,	0,					\
		DamageSolidity, 0,	"DamageSolidity",	ATXVALTYPE_FLOAT32,	0


OBJVALINDIRECTS InstanceName,	CAnimal.lpCBrain,CBrain.ParentInstanceNameString
OBJVALINDIRECTS BaseAddress,	0
OBJVALINDIRECTS NameHash,	CInstance.InstanceNameID
OBJVALINDIRECTS Location,	CInstance.Location
OBJVALINDIRECTS HitPoints,	CAnimate.HitPoints
OBJVALINDIRECTS MaxHitPoints,	CAnimate.MaxHitPoints
OBJVALINDIRECTS Sleep,		CAnimal.lpCBrain,CBrain.Sleep
OBJVALINDIRECTS WakeUp, 	CAnimal.lpCBrain,CBrain.WakeUp
OBJVALINDIRECTS Bravery,	CAnimal.lpCBrain,CBrain.Bravery
OBJVALINDIRECTS Fear,		CAnimal.lpCBrain,CBrain.lpCMentalState,CMentalState.Fear
OBJVALINDIRECTS Love,		CAnimal.lpCBrain,CBrain.lpCMentalState,CMentalState.Love
OBJVALINDIRECTS Anger,		CAnimal.lpCBrain,CBrain.lpCMentalState,CMentalState.Anger
OBJVALINDIRECTS Curiosity,	CAnimal.lpCBrain,CBrain.lpCMentalState,CMentalState.Curiosity
OBJVALINDIRECTS Hunger, 	CAnimal.lpCBrain,CBrain.lpCMentalState,CMentalState.Hunger
OBJVALINDIRECTS Thirst, 	CAnimal.lpCBrain,CBrain.lpCMentalState,CMentalState.Thirst
OBJVALINDIRECTS Fatigue,	CAnimal.lpCBrain,CBrain.lpCMentalState,CMentalState.Fatigue
OBJVALINDIRECTS Pain,		CAnimal.lpCBrain,CBrain.lpCMentalState,CMentalState.Pain
OBJVALINDIRECTS Solidity,	CAnimal.lpCBrain,CBrain.lpCMentalState,CMentalState.Solidity
OBJVALINDIRECTS HumanFear,	CAnimal.lpCBrain,CBrain.HumanFear
OBJVALINDIRECTS HumanLove,	CAnimal.lpCBrain,CBrain.HumanLove
OBJVALINDIRECTS HumanAnger,	CAnimal.lpCBrain,CBrain.HumanAnger
OBJVALINDIRECTS HumanCuriosity, CAnimal.lpCBrain,CBrain.HumanCuriosity
OBJVALINDIRECTS HumanHunger,	CAnimal.lpCBrain,CBrain.HumanHunger
OBJVALINDIRECTS HumanThirst,	CAnimal.lpCBrain,CBrain.HumanThirst
OBJVALINDIRECTS HumanFatigue,	CAnimal.lpCBrain,CBrain.HumanFatigue
OBJVALINDIRECTS HumanPain,	CAnimal.lpCBrain,CBrain.HumanPain
OBJVALINDIRECTS HumanSolidity,	CAnimal.lpCBrain,CBrain.HumanSolidity
OBJVALINDIRECTS DamageFear,	CAnimal.lpCBrain,CBrain.DamageFear
OBJVALINDIRECTS DamageLove,	CAnimal.lpCBrain,CBrain.DamageLove
OBJVALINDIRECTS DamageAnger,	CAnimal.lpCBrain,CBrain.DamageAnger
OBJVALINDIRECTS DamageCuriosity,CAnimal.lpCBrain,CBrain.DamageCuriosity
OBJVALINDIRECTS DamageHunger,	CAnimal.lpCBrain,CBrain.DamageHunger
OBJVALINDIRECTS DamageThirst,	CAnimal.lpCBrain,CBrain.DamageThirst
OBJVALINDIRECTS DamageFatigue,	CAnimal.lpCBrain,CBrain.DamageFatigue
OBJVALINDIRECTS DamagePain,	CAnimal.lpCBrain,CBrain.DamagePain
OBJVALINDIRECTS DamageSolidity, CAnimal.lpCBrain,CBrain.DamageSolidity
OBJVALINDIRECTS ActJumpNewInfo, 0