;==========================================================
ATXINITPROC INI_CHECKNEWHOTKEYSINITPROC
;==========================================================
; SCANS FOR CHEAT HOTKEYS AND CREATES PROC TABLE FOR KEY HANDLER
; must be called only after all cheats have been set up
; note: CheatHotKeyTableRT defined in console cheat listing data

push esi
push edi
push ebx

	mov esi,Cheattable					; 8 bytes per cheat
	mov edi,CheatHotKeyTableRT
	xor ebx,ebx

	mov eax,[TotalCheats]
	push eax

	cmp eax,DEFAULT_TOTAL_CHEAT_COUNT
	ja .exitloop

	.iniscanloop:

    ; DWORD [esi] = pointer to cheat string name = name of key

	sub esp,4
	mov eax,esp
	invoke GetPrivateProfileString,section_hotkeys,[esi],ZERO_STRING,eax,4,atxconfigpath_const
	pop eax

	and eax,0FFh
	test al,al
	jz .skipentry
	cmp al,'0'
	jz .skipentry
	cmp al,';'
	jz .skipentry

		CHAR_TOLOWERCASE al

		mov [edi+CheatHotKeyTableEntry.KeyValue],eax
		mov [edi+CheatHotKeyTableEntry.CheatIndex],ebx

		add edi,sizeof.CheatHotKeyTableEntry		; only add to table if a valid key was found (otherwise, too many empty table members for nothing)

	.skipentry:
	add esi,8
	inc ebx
	dec DWORD [esp]
	jnz .iniscanloop

	.exitloop:

	pop eax

pop ebx
pop edi
pop esi
ret


;==========================================================
ATXINITPROC UpdateATXConfigINIHotkeys
;==========================================================
; ebp = file handle

; uses ATXConfigValueBuffer

push esi

	mov esi,CheatHotKeyTableRT

	.newhotkeysloop:
	cmp [esi+CheatHotKeyTableEntry.KeyValue],0
	jz .newhotkeysloopend

	lea edx,[esi+CheatHotKeyTableEntry.KeyValue]
	mov eax,[esi+CheatHotKeyTableEntry.CheatIndex]

	cinvoke wsprintf,ATXConfigValueBuffer,INI_KEYVALUE_STR_TEMPLATE_CRET,\
			 DWORD [Cheattable+8*eax],edx

	sub esp,4
	lea edx,[esp]
	invoke WriteFile,ebp,ATXConfigValueBuffer,eax,edx,0
	add esp,4

	add esi,sizeof.CheatHotKeyTableEntry
	jmp .newhotkeysloop

	.newhotkeysloopend:


pop esi
ret
