struct CAT107 CATNEW
ends

; must begin all atxdrv structures
struct atxdrv_base
       VTable			dd	?
       Ref			dd	?
       Type			dd	?
       Instance 		dd	?
       TempInstance		dd	?
ends

struct atxdrv_type1					; should be DWORD aligned, no negative values
       VTable			dd	?		; standard
       Ref			dd	?
       Type			dd	?
       Instance 		dd	?
       TempInstance		dd	?
       Tick			dd	?		; keyrate limiter
       FWDFast			dd	?		; acceleration values
       FWDSlow			dd	?
       BackSlow 		dd	?		; -> BackSlow = negative value
       BackBrake		dd	?		; -> BackBrake = negative value
       LeftRight		dd	?
       FastLimit		dd	?		; velocity values (do not apply acceleration
       SlowLimit		dd	?		; if velocity is higher than these values in object's current
       BackLimit		dd	?		; direction)   -> BackLimit = negative value
       LeftRightLimit		dd	?
       MvtZAngleMul		dd	?
       UseQuatMulInvert 	dd	?
ends

struct atxdrv_initial_velocity
       XVelocity		dd	?
       YVelocity		dd	?
       ZVelocity		dd	?
       WQuat			dd	?
       XQuat			dd	?
       YQuat			dd	?
       ZQuat			dd	?
ends

struct atxdrv_inst_data 				; should be DWORD aligned, no negative values
       VTable			dd	?
       Ref			dd	?
       Type			dd	?
       Instance 		dd	?
       TempInstance		dd	?
       GravityPush		dd	?
       KeyHandlerTick		dd	?
       MvtHandlerTick		dd	?
       RotPosOffset		dd	?		; rotation position offset (1D, offsets effect of rotation)
       FrontFastAccel		dd	?		; floats/s^2 (acceleration)
       FrontSlowAccel		dd	?
       BackSlowAccel		dd	?
       BackBrakeDecel		dd	?		; used when velocity > 0
       NaturalDecel		dd	?		; used when no mvt keys pressed
       RotationAccelL		dd	?		; should be positive - rotation acceleration (left and right) (radian angles/S^2)
       RotationAccelR		dd	?		; should be negative
       RotationDecel		dd	?		; used when no rotation keys pressed (should be high)
       MaxFastVelocity		dd	?
       MaxSlowVelocity		dd	?		; approximate
       MaxBackVelocity		dd	?		; CONVERT FROM POSITIVE TO NEGATIVE
       MaxTurnVelocityL 	dd	?
       MaxTurnVelocityR 	dd	?		; CONVERT FROM POSITIVE TO NEGATIVE
       MinVelocityForTurn	dd	?
ends
