; Wrap methods. Called functions all received the "this" pointer
; as first parameter (and not explicit). The "this" pointer does
; not point to the base of the instance, but rather to the logical
; instance as seen by plugin (which follows the new AT instance header).

;==========================================================
ATXPROC PLUGINATDESTR
;==========================================================
push esi
mov esi,ecx

	mov eax,[ecx+PLUGIN_NEWAT_HEADER.lpDestr]
	test eax,eax
	     jz .nocallback

		lea edx,[esi+sizeof.PLUGIN_NEWAT_HEADER]
		stdcall eax,edx

	.nocallback:

	push DWORD [esp+8]
	mov ecx,esi
	call NewATMainDestructor

pop esi
ret 4

;==========================================================
ATXPROC PLUGINATMAIN
;==========================================================

	lea edx,[ecx+sizeof.PLUGIN_NEWAT_HEADER]
	mov eax,[ecx+PLUGIN_NEWAT_HEADER.lpMainProc]
	stdcall eax,edx

ret


;==========================================================
ATXPROC PLUGINAT_REINIT
;==========================================================

	mov eax,[ecx+PLUGIN_NEWAT_HEADER.lpReInitProc]
	test eax,eax
	     jz .nocallback

		lea edx,[ecx+sizeof.PLUGIN_NEWAT_HEADER]
		stdcall eax,edx

	.nocallback:

mov eax,[esp+4]
ret 4














