;============================================================
macro GETINSTANCEVELOCITYVALUES resultAddr, lpInstance {
;============================================================

	push lpInstance
	push resultAddr

	if ~ lpInstance eq edx
	  mov edx,lpInstance
	end if

	mov eax,[edx+CInstance.lpCInfo]
	mov ecx,[eax+CInfo.lpCPhysicsInfo]
	mov eax,[ecx]
	call DWORD [eax+28h]

      }

;============================================================
macro GETINSTANCEPHYSICSINDEX _instance {	; returns in eax
;============================================================

	if _instance eq eax			; NOTE: does not prevent indexed addressing with eax!
	   mov edx,[GETOBJPHYSICSOBJADDR]
	   push _instance
	   mov ecx,[edx]
	else
	   mov eax,[GETOBJPHYSICSOBJADDR]
	   push _instance
	   mov ecx,[eax]
	end if

	call [GetObjPhysicsIndexProc]		; ecx = sub-instance, already set

      }

;============================================================
macro ADJUSTVELOCITYPOINTER {			; must be in eax, and returns in eax ; ecx/edx destroyed
;============================================================
	local .fullversion,.demoversion

	cmp [EXEID],'DEMO'
	    jnz .fullversion

	mov ecx,eax				; for DEMO EXE
	shl ecx,5
	add ecx,eax
	lea eax,[eax+8*ecx]
	shl eax,4
	jmp .demoversion

	.fullversion :
	mov ecx,eax				; for full version EXEs
	shl ecx,6
	add ecx,eax
	lea edx,[eax+2*ecx]
	lea eax,[eax+8*edx]
	shl eax,2

	.demoversion:

	add eax,[OBJPHYSICSBASEADDR]

      }

;==========================================================
MACRO GETINSTANCEPHYSICSINFO regdest, regsource {
;==========================================================
; Returns game speed float in a 32-bit register (not FPU stack)

	mov regdest,[regsource+CInstance.lpCInfo]
	mov regdest,[regdest+CInfo.lpCPhysicsInfo]

      }

;==========================================================
MACRO GETGAMESPEEDVALUEREG reg1 {
;==========================================================
; Returns game speed float in a 32-bit register (not FPU stack)

	mov reg1,[GAME_SPEED_VAR_ADDR]
	mov reg1,[reg1]

      }

;==========================================================
MACRO GETGAMESPEEDVALUEADDR reg1 {
;==========================================================

	mov reg1,[GAME_SPEED_VAR_ADDR]

      }

;==========================================================
MACRO GETGRAVITYVALUEREG reg1 {
;==========================================================
; Returns gravity float in a 32-bit register (not FPU stack)

	mov reg1,[GRAVITY_VAR_ADDR]
	mov reg1,[reg1]

      }

;==========================================================
MACRO GETGRAVITYVALUEADDR reg1 {
;==========================================================

	mov reg1,[GRAVITY_VAR_ADDR]

      }
