
; Note: BB stands for Back Buffer, DD stands for DirectDraw (not a typo!)

;============================================================
macro GETMAINCRASTERWININSTANCE reg1 {
;============================================================

	mov reg1,[DDSURFACE_BASE_ADDR]
	mov reg1,[reg1]

      }


;============================================================
macro GETBBSURFACEOBJNONULL reg1 {
;============================================================

      local .nosurface

	GETMAINCRASTERWININSTANCE reg1
	test reg1,reg1
	jz .nosurface

		mov reg1,[reg1+CRasterWin.lpDDSurfaceBackBuffer]

	.nosurface:

      }


;============================================================
macro GETBBSURFACEDIMENSIONS reg1 {
;============================================================

      local .noddsurface

	GETMAINCRASTERWININSTANCE reg1

	test reg1,reg1
	jz .noddsurface

		lea reg1,[reg1+CRasterWin.Width]		; reg = pointer to back buffer DDSurface object

	.noddsurface:

      }


;============================================================
macro GETTRESSURFACEOBJSECONDSURFACEADDR reg1 {
;============================================================

      local .nosurface

	GETMAINCRASTERWININSTANCE reg1
	test reg1,reg1
	jz .nosurface

		lea reg1,[reg1+CRasterWin.lpDDSurfacePrimary]	; reg1 = pointer to secondary DDSurface object (used by SMK playback code)

	.nosurface:

      }



;============================================================
macro DDSURFACERELEASE lpDDSurface {
;============================================================

      local .nosurface

	mov ecx,lpDDSurface
	test ecx,ecx
	jz .nosurface

		mov eax,[ecx]
		push ecx
		call DWORD [eax+DirectDrawSurface.Release]

	.nosurface:
      }


;============================================================
macro GETTRESDDOBJNOD3D reg1 {
;============================================================

	mov reg1,[DDRAW_OBJ_BASE]
	mov reg1,[reg1]

      }


;============================================================
macro GETTRESDDOBJD3D reg1 {
;============================================================

	mov reg1,[DDRAW_OBJ_BASE]
	mov reg1,[reg1+4]

      }