;=======================================================
proc UpdatePlayerSpotLight uses esi ebx
;=======================================================

   local lightDir:VECTOR

	mov ebx,[MAINCDIRECT3DINFOOBJ_ADDR]
	mov ecx,[ebx+CDirect3DInfo.lpIDirect3DDevice3Obj]
	push 0xffffffff
	push D3DLIGHTSTATE_AMBIENT
	push ecx
	mov eax,[ecx]
	call [eax+IDirect3DDevice3.SetLightState]


	cmp [PlayerSpotLightD3DLight],0
	jnz .alreadyregistered

		mov [PlayerSpotLightParams.Flags],ATXSPOTLIGHT_ISENABLED
		mov [PlayerSpotLightParams.LightColor.R],50.0f
		mov [PlayerSpotLightParams.LightColor.G],50.0f
		mov [PlayerSpotLightParams.LightColor.B],50.0f
		mov [PlayerSpotLightParams.LightColor.A],0.5f
		mov [PlayerSpotLightParams.Position.X],3.2f
		mov [PlayerSpotLightParams.Position.Y],-2.7f
		mov [PlayerSpotLightParams.Position.Z],1.8f
		mov [PlayerSpotLightParams.Direction.X],0f
		mov [PlayerSpotLightParams.Direction.Y],1f
		mov [PlayerSpotLightParams.Direction.Z],0f
		mov [PlayerSpotLightParams.Range],20.0f
		mov [PlayerSpotLightParams.Falloff],1.0f
		mov [PlayerSpotLightParams.Attenuation.A0],0.5f
		mov [PlayerSpotLightParams.Attenuation.A1],0.5f
		mov [PlayerSpotLightParams.Attenuation.A2],0.5f
		mov [PlayerSpotLightParams.InnerConeAngle],0.523f
		mov [PlayerSpotLightParams.OuterConeAngle],0.785f

		stdcall RegisterSpotLight,PlayerSpotLightParams
		test eax,eax
		jz .error
		mov [PlayerSpotLightD3DLight],eax

	.alreadyregistered:


	GETCCAMERAINSTANCE esi

	push 0
	lea edx,[lightDir]
	lea ecx,[esi+CInstance.OrientationQuat]
	push edx
	call CONVERT_TO_FACING_PROC_010

	lea edx,[esi+CInstance.Location]
	lea eax,[lightDir]

	stdcall UpdateSpotLightPosDir,[PlayerSpotLightD3DLight],edx,eax


ret

.error:

ret
endp