; Compile using FASM. Version used for last release: 1.66 (May 7, 2006)

;NO ERROR CHECKING!!! ASSUMES EVERYTHING!!!
;NEEDS 4 UNALTERED TRESPASSER EXECUTABLES IN SAME DIRECTORY. ASSUMES
;PRESENCE, DOES NOT CHECK FOR VALIDITY:
;ONLY FOR P611 EXE !!!!!!!!!!!!!!!!!!!!!

;OUTPUTS FOLLOWING FILES
;tresclasses.inc (compiled from P611 only)
;tresclassinterfaces.inc

VTABLEIDVERSION 	equ	'1.0'

format PE GUI 4.0
entry START
stack 40000h

include '%fasminc%\WIN32A.INC'	;must have FASM environment variable set properly for this

_exe_P6_1_1_Size	equ	2555904 	;EXE sizes for detection
_exe_P5_1_1_Size	equ	2580480
_exe_K6_1_1_Size	equ	2351104
_exe_P5_Demo_Size	equ	2600960

;For all Trespasser 1.1 EXE VTables (for most classes)
;DWORD [VTable-4] points to DebugObject1
;DWORD [DebugObject1+0Ch] points to ((?.AV-string address) - 8 )
;*****
;DWORD [((?.AV-string address) - 8 )] holds a one-member VTable which is the
;same for most or all AV-string addresses; most likely a class on its own (or the like).

MACRO TOMEMADDR reg1 {
      sub reg1,[source_exe_read]
      add reg1,[rdata_section_offset]
      add reg1,00400000h
      }

MACRO TOFILEADDR reg1 {
      sub reg1,00400000h
      sub reg1,[rdata_section_offset]
      add reg1,[source_exe_read]
      }

MACRO FINDSTRINGEND reg1 {
local NoNullTerminator,StringSizeNull
      cmp BYTE [reg1],0
	  jz StringSizeNull
      NoNullTerminator:
      inc reg1
      cmp BYTE [reg1],0
	  jnz NoNullTerminator
      StringSizeNull:
      }

;=================================================================
section '.code' code readable executable
;=================================================================
START:
push ebp
push ebx
push edi
push esi

       invoke GetModuleHandle,0
       mov [module_handle],eax

       invoke GetModuleFileName,[module_handle],currentprocessnamebuffer,512

       mov edi,currentprocessnamebuffer
       FINDSTRINGEND edi

       findbackslashloop:
       dec edi
       cmp BYTE [edi],'\'
	   jnz findbackslashloop
       inc edi
       mov esi,import_filename

       call TransferString

;open P611.exe
invoke CreateFile,exename_p611,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,\
			FILE_ATTRIBUTE_NORMAL,0,0
       test eax,eax
       mov [source_exe_handle],eax
	   jz MAINEXIT
       cmp eax,-1
	   jz MAINEXIT

	   mov [rdata_section_offset],DWORD 00242000h
	   mov [data_section_end],DWORD 0026A000h
	   mov [code_section_size],DWORD 00237000h

;create buffer for P611.exe data
       mov eax,[data_section_end]
       sub eax,[rdata_section_offset]
       mov [source_read_size],eax
       add eax,4
invoke LocalAlloc,LMEM_FIXED,eax
       test eax,eax
       mov [source_exe_read],eax
	    jz MAINEXIT
       add eax,[source_read_size]
       mov [source_end_read_buf],eax

;read P611.exe data into buffer
invoke SetFilePointer,[source_exe_handle],[rdata_section_offset],0,FILE_BEGIN
       cmp eax,-1
	   jz MAINEXIT

invoke ReadFile,[source_exe_handle],[source_exe_read],[source_read_size],temp_var,0
       test eax,eax
       mov ecx,[source_read_size]
	    jz MAINEXIT
       cmp ecx,[temp_var]
	   jnz MAINEXIT

invoke CloseHandle,[source_exe_handle]

;Create buffer to contain a series of DWORD addresses pointing into P611.exe data
;buffer, to the start of all found ".?AV" strings (fixed size; VTABLEID.EXE reports max 520 classes)
invoke LocalAlloc,LPTR,(520*4)
       mov [classnameslpbuf],eax

;create buffer to hold vtable lengths (for all exes, assumed)
invoke LocalAlloc,LPTR,(520*4)
       mov [vtablelengthsbuf],eax

;create buffer to hold class name lengths (for all exes, assumed)
invoke LocalAlloc,LPTR,(520*4)
       mov [classnamesizebuf],eax

invoke LocalAlloc,LPTR,(520*4)
       mov [vtablesuboneaddrbuf],eax

;/* NEW: TEMPORARY VTABLES BUFFER

invoke LocalAlloc,LPTR,(520*4)
       mov [vtablestempbuffer],eax

;*/

       mov ebx,[source_exe_read]
       add ebx,8

;============================================================
;P611 MAIN LOOP
;============================================================

;--------------------------------
;MAIN .?AV SEARCH LOOP
;--------------------------------
AVSearchLoop:
       add ebx,4
       stdcall FindDataInBuffer,searchstr_avc,4,ebx,[source_end_read_buf]
       test eax,eax
       mov ebx,eax
	    jz END_AVSearchLoop

       mov al,[ebx+4]
       cmp al,'C'
	   jz AVSearchLoop_CHECKFIRSTCHAR_OK
       cmp al,'T'			      ;for TPartitionList
	   jz AVSearchLoop_CHECKFIRSTCHAR_OK
       cmp al,'t'			      ;for type_info
	   jz AVSearchLoop_CHECKFIRSTCHAR_OK
       jmp AVSearchLoop
       AVSearchLoop_CHECKFIRSTCHAR_OK:

       stdcall FindDataInBuffer,searchstr_0,1,ebx,[source_end_read_buf]
       test eax,eax
	    jz END_AVSearchLoop
       mov edi,eax
       sub eax,2
       cmp WORD [eax],'@@'
	   jnz AVSearchLoop

       stdcall FindDataInBuffer,searchstr_at,1,ebx,eax	 ;make sure no single '@' character is in class name
       test eax,eax
	    jnz AVSearchLoop

       mov ecx,edi
       mov eax,[classnamesizebuf]
       sub ecx,ebx
       add ecx,1		;include null-terminator in size
       mov edx,[classindex]
       mov [eax+edx],ecx	;temporary save of class name length

;--------------------------------
;FIRST SUB-LOOP (FINDS POINTERS TO ((AV STRING ADDRESS) - 8) )
;--------------------------------
       mov edi,[source_exe_read]
       lea eax,[ebx-8]		;last reference address/offset
       add edi,(0Ch-1)
       TOMEMADDR eax
       mov [currADDRvalue],eax

   ADDRSearchLoop:
       mov eax,[source_end_read_buf]
       inc edi
       sub eax,18h
       stdcall FindDWORDInBuffer,[currADDRvalue],edi,eax
       test eax,eax
       mov edi,eax
	    jz AVSearchLoop

       lea eax,[edi-0Ch]
       TOMEMADDR eax
       mov [currADDRSUBvalue],eax	       ;value of DWORD [VTable-4]

;--------------------------------
;SECOND SUB-LOOP (FINDS VTABLE)
;--------------------------------
       mov esi,[source_exe_read]
       add esi,(-1)

   ADDRSUBSearchLoop:
       mov eax,[source_end_read_buf]
       inc esi
       sub eax,4
       stdcall FindDWORDInBuffer,[currADDRSUBvalue],esi,eax
       test eax,eax
       mov esi,eax
	    jz ADDRSearchLoop

;/* NEW
;TEST FOR EXCEPTION: CUIListBox VTable (there are two and only one is the main,
;second most likely for inner-class declaration)
;VTable used must be _MAIN, not _SUB
       TOMEMADDR eax
       cmp eax,(00642608h)-4
	   jz ADDRSUBSearchLoop

;*/
       mov eax,[esi+4]			;get first VTable member (+00h)
       mov edx,[code_section_size]
       cmp eax,00401000h		;make sure within EXE code section/valid proc, or is a dud and must find another
	   jb ADDRSUBSearchLoop
       add edx,00401000h
       cmp eax,edx
	   jnb ADDRSUBSearchLoop

       add esi,4
       mov ecx,[classindex]
       mov eax,[classnameslpbuf]
       mov [eax+ecx],ebx

       stdcall GetVTableLength,esi
       mov edx,[vtablelengthsbuf]
       mov ecx,[classindex]
       mov [edx+ecx],eax
       mov eax,[currADDRSUBvalue]    ;save last (current) [currADDRSUBvalue] value for later (inheritance)
       mov edx,[vtablesuboneaddrbuf]
       mov [edx+ecx],eax

;/* NEW: SAVE VTABLE TEMPORARILY

       mov edx,[vtablestempbuffer]
       mov [edx+ecx],esi

;*/

       add ecx,4
       mov [classindex],ecx
       jmp AVSearchLoop
;============================================================
END_AVSearchLoop:
;============================================================

;/* NEW: CREATE INTERFACES FILES

invoke CreateFile,interfaces_filename,GENERIC_WRITE,0,0,CREATE_ALWAYS,\
			FILE_ATTRIBUTE_NORMAL,0,0
       mov [interfaces_filehandle],eax

invoke SetFilePointer,[interfaces_filehandle],0,0,FILE_BEGIN


invoke WriteFile,[interfaces_filehandle],interfacetemplateheader,interfacetemplateheader_end-interfacetemplateheader,byteswritten,0

;*/

;============================================================
;CREATE:
;tresclasses.inc (contains classes + vtables, compiled from P611 only)
;tresvtbasedataext.inc
;============================================================

invoke CreateFile,tresclasses,GENERIC_WRITE,FILE_SHARE_WRITE,0,CREATE_ALWAYS,\
			FILE_ATTRIBUTE_NORMAL,0,0
       mov ebx,eax
invoke SetFilePointer,ebx,0,0,FILE_BEGIN

;/* NEW!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;  For FASM STRUCT definitions, inherited classes must be declared
;  before all others, so we must create in-file the interfaces of classes
;  with the least inherited classes first and the ones with the most last.
;  -> MUST GO THROUGH LOOP WITH CLASS INHERITANCE COUNT BEGINNING AT
;     1 AND END WHEN THERE ARE NO MORE CLASSES LEFT TO DEFINE
;note: the order will not be absolute but almost always produces correct
;inheritance patterns. Some classes will be labelled as having many inherited
;classes, but none are valid. And so they will appear nearear to EOF even
;though they inherit nothing using STRUCT.

       mov [CURRENT_INHERITANCE_COUNT],0

TRESCLASSESCREATELOOP_OUTSIDELOOP:
       mov [TRESCLASSESCREATELOOP_RUNONCE],FALSE
       inc [CURRENT_INHERITANCE_COUNT]
       xor ebp,ebp

;============================================================
TRESCLASSESCREATELOOP:
;============================================================

;/* NEW
       mov eax,[vtablesuboneaddrbuf]
       mov edx,[eax+ebp]
       TOFILEADDR edx
       mov edx,[edx+10h]
       TOFILEADDR edx
       mov ecx,[edx+8]		     ;number of inherited classes
       cmp ecx,[CURRENT_INHERITANCE_COUNT]
	   jnz TRES_CLASSES_CREATE_LOOP_ENDCHECK

       mov [TRESCLASSESCREATELOOP_RUNONCE],TRUE
;*/


;copy main class name                             ;temp_buf2
       mov eax,[classnameslpbuf]
       mov edx,[classnamesizebuf]
       mov esi,[eax+ebp]
       mov ecx,[edx+ebp]
       add esi,4
       sub ecx,(2+4+1)
       mov edi,temp_buf+1000
       rep movsb		     ;move class name
       mov BYTE [edi],0 	     ;add null-terminator

;copy inherited class names

       mov eax,[vtablesuboneaddrbuf]
       mov edx,[eax+ebp]
       TOFILEADDR edx
       mov edx,[edx+10h]
       TOFILEADDR edx
       mov ecx,[edx+8]		     ;number of inherited classes
       mov edx,[edx+12]
       TOFILEADDR edx		     ;edx = points to list of pointers to pointers of class names

       mov edi,(temp_buf2+2)
       CopyClassInheritanceNames:
		mov DWORD [edi-2],0000202Ch
		mov eax,[edx]
		TOFILEADDR eax
		mov eax,[eax]
		TOFILEADDR eax
		lea esi,[eax+0Ch]
		call TransferString
		add edx,4
       loop CopyClassInheritanceNames
		mov BYTE [edi-2],00h

;get length of vtable
       mov eax,[vtablelengthsbuf]
       mov edx,[eax+ebp]
       mov ecx,temp_buf+1000
       mov eax,edx
       shr edx,2

       invoke wsprintf,temp_buf,customstructemplate,ecx,(temp_buf2+2),edx,ecx,eax
       add esp,(7*4)

       invoke WriteFile,ebx,temp_buf,eax,byteswritten,0


;/* NEW: CREATE INTERFACE DATA
push ebx


;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! MUST GET NEAREST INHERITED CLASS HERE!!!!! + KEEP METHOD COUNT FOR NEAREST INHERITED CLASS!!!!!

       mov BYTE [temp_buf+999],'I'		;i.e., ICAnimal interface

;GET NEAREST AND MOST IMPOSING INHERITED CLASS NAME (ONLY CLASSES WITH VTABLES IN LIST ARE ALLOWED)

       mov eax,[vtablesuboneaddrbuf]
       mov edx,[eax+ebp]
       TOFILEADDR edx
       mov edx,[edx+10h]
       TOFILEADDR edx
       mov ecx,[edx+8]		     ;number of inherited classes
       mov edx,[edx+12]
       TOFILEADDR edx		     ;edx = points to list of pointers to pointers of class names


;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! MUST SCAN THROUGH ALL INHERITED CLASSES TO FIND FIRST VALID CLASS; SOMETIMES NEXT CLASS IS INVALID
;if valid inherited class found, puts
;'I' at BYTE [temp_buf+1999]
;class index in esi
;puts class name at [temp_buf+2000] and removes @@
;
;if not found, puts
;null-terminator at BYTE [temp_buf+1999]
;-1 in esi
;
;temp vars:
;edi = remaining class count (exits if 1)
;ebx = index for list

       mov BYTE [temp_buf+1999],0
       mov esi,-1

       mov ebx,edx
       mov edi,ecx		   ;(count includes self)

       dec edi			   ;was count already 1?
	   jz NoInheritedClassesA

       InheritedClassesA_LOOP:	   ;searches for first valid class in inheritance list
		add ebx,4		;points to next class in inheritance chain
		mov eax,[ebx]
		TOFILEADDR eax
		mov eax,[eax]
		TOFILEADDR eax
	    push edi
	    push esi
		lea esi,[eax+0Ch]	;points to class name
		mov edi,temp_buf+2000
		call TransferString	;move string to temp_buf+2000
	    pop esi
	    pop edi
		stdcall IsValidClass,temp_buf+2000
		test eax,eax
		     jnz InheritedClassesA_FOUND

       dec edi
	   jnz InheritedClassesA_LOOP
       jmp NoInheritedClassesA
       InheritedClassesA_FOUND:
		mov esi,ecx		     ;class index
		mov edi,(temp_buf+1999)
		mov BYTE [edi],'I'	     ;i.e., ICObject
		FINDSTRINGEND edi
		mov BYTE [edi-2],0	;remove @@
       NoInheritedClassesA:

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

;print interface name + method count

       mov eax,[vtablelengthsbuf]
       mov edx,[eax+ebp]
       shr edx,2
       mov ebx,edx		    ;number of methods in VTable
       mov eax,[vtablestempbuffer]  ;get P611 VTable
       mov edx,[eax+ebp]
       TOMEMADDR edx

       mov eax,interfacesinheritkeyword
       mov ecx,SPACE_STRING
       cmp BYTE [temp_buf+1999],0
	   jnz @f
       mov eax,EMPTY_STRING
       mov ecx,EMPTY_STRING
       @@:

       cinvoke wsprintf,temp_buf,interfacestemplatestart,(temp_buf+999),eax,(temp_buf+1999),ecx,ebx
       invoke WriteFile,[interfaces_filehandle],temp_buf,eax,byteswritten,0

;MAIN METHOD PRINT LOOP

       ;!!!!!!!!!!!!!!! esi = class index of inherited class (or -1)
       ;!!!!!!!!!!!!!!! ebx = number of methods in current class

       mov eax,[vtablestempbuffer]
       mov edi,[eax+ebp]		;pointer to VTables

       cmp esi,-1
       mov ecx,0
	   jz NOINHERITEDCLASS_A
       mov eax,[vtablelengthsbuf]
       mov edx,[eax+esi]
       shr edx,2			;edx = number of methods in inherited class
       sub ebx,edx			;are all methods of current class defined in inherited class
	   jz END_INTERFACE_DEF_NOW
	   lea ecx,[edx*4]		;start at offseted method
       NOINHERITEDCLASS_A:

       mov esi,ecx		;esi=counter

       MAINMETHODPRINTLOOP:

		call GET_METHOD_LABEL

       cinvoke wsprintf,temp_buf,interfacestemplatemember,temp_buf+500,EMPTY_STRING,esi
       invoke WriteFile,[interfaces_filehandle],temp_buf,eax,byteswritten,0
       add esi,4
       dec ebx
	   jnz MAINMETHODPRINTLOOP

END_INTERFACE_DEF_NOW:
;end structure

       cinvoke wsprintf,temp_buf,interfacestemplateend,(temp_buf+999)
       invoke WriteFile,[interfaces_filehandle],temp_buf,eax,byteswritten,0


pop ebx
;*/


TRES_CLASSES_CREATE_LOOP_ENDCHECK:
       add ebp,4
       cmp ebp,[classindex]
	   jb TRESCLASSESCREATELOOP


;OUTSIDE LOOP
       cmp [TRESCLASSESCREATELOOP_RUNONCE],TRUE
	   jz TRESCLASSESCREATELOOP_OUTSIDELOOP

invoke CloseHandle,ebx

invoke CloseHandle,[interfaces_filehandle]

invoke LocalFree,[vtablestempbuffer]

;============================================================
invoke MessageBox,0,error_success_1,msgbox_caption,0
;============================================================
MAINEXIT:
;============================================================

invoke LocalFree,[source_exe_read]
invoke LocalFree,[classnameslpbuf]
invoke LocalFree,[vtablelengthsbuf]
invoke LocalFree,[classnamesizebuf]
invoke LocalFree,[vtablesuboneaddrbuf]
invoke CloseHandle,[source_exe_handle]
invoke CloseHandle,[interfaces_filehandle]

       pop esi
       pop edi
       pop ebx
       pop ebp
invoke ExitProcess,0

;============================================================
GetVTableLength:	;[esp+4] = memory address
;============================================================
push ebx

       mov ebx,[esp+8]
       mov ecx,00401000h
       mov edx,[code_section_size]
       add edx,ecx

       GetVTableLength_LOOP:
       mov eax,[ebx]
       cmp eax,ecx
	   jb GetVTableLength_LOOP_END
       cmp eax,edx
	   jnb GetVTableLength_LOOP_END
       add ebx,4
       jmp GetVTableLength_LOOP
GetVTableLength_LOOP_END:

       mov eax,ebx
       sub eax,[esp+8]

pop ebx
ret

;============================================================
TransferString: 	;esi=source, edi=dest., destroyed: esi,edi, al
;============================================================
TransferStringLoop: ;edi points to dest.'s null-terminator (BYTE [edi] = 0)
     mov al,[esi]
     mov [edi],al	      ;transfer/append string
     test al,al
	  jz End_TransferStringLoop
     inc esi
     inc edi
     jmp TransferStringLoop
End_TransferStringLoop:
ret

;============================================================
TransferStringTOUP:	    ;esi=source, edi=dest., ecx = length of
;============================================================
TransferStringLoopTOUP: ;edi points to dest.'s null-terminator (BYTE [edi] = 0)
     mov al,[esi]
     cmp al,'a'
	 jb TransferStringLoopTOUP_NOTOUP
     cmp al,'z'
	 ja TransferStringLoopTOUP_NOTOUP
	 sub al,20h
     TransferStringLoopTOUP_NOTOUP:
     mov [edi],al	      ;transfer/append string
     inc esi
     inc edi
     dec ecx
       jnz TransferStringLoopTOUP
End_TransferStringLoopTOUP:
ret


;============================================================
FindDWORDInBuffer:     ;[esp+4] = DWORD to find, [esp+8] = address to start looking from, [esp+12] = max address
;============================================================
		       ;returns ---- in EDI ---- address if found or NULL

	mov ecx,[esp+12]
	mov edx,[esp+8]
	sub ecx,4
	xor eax,eax
	cmp ecx,edx
	    jna FindDWORDInBuffer_EXIT

	mov eax,[esp+4]
FindDWORDInBufferLOOP:
	cmp [edx],eax
	    jz FindDWORDInBufferFOUND
	inc edx
	cmp edx,ecx
	    jb FindDWORDInBufferLOOP
	xor edx,edx
FindDWORDInBufferFOUND:
	mov eax,edx
FindDWORDInBuffer_EXIT:
ret 12

;============================================================
FindDataInBuffer:
;============================================================
;[esp+4] = pointer to data to find, [esp+8] = size of data buffer
;[esp+12] = address to start looking from, [esp+16] = max address
;returns address of found data in eax or NULL if not found
push ebp
mov ebp,esp
push esi
push edi
push ebx

	mov ebx,[ebp+20]
	mov edx,[ebp+16]
	sub ebx,[ebp+12]
	xor eax,eax
	cmp ebx,edx
	    jna FindDataInBuffer_EXIT

FindDataInBuffer_LOOP:
	mov esi,edx
	mov edi,[ebp+8]
	mov ecx,[ebp+12]
	repz cmpsb
	     jnz FindDataInBuffer_FOUND_NOT
	test ecx,ecx
	     jz FindDataInBuffer_FOUND
	FindDataInBuffer_FOUND_NOT:
	inc edx
	cmp edx,ebx
	    jb FindDataInBuffer_LOOP

	xor eax,eax

FindDataInBuffer_EXIT:
pop ebx
pop edi
pop esi
mov esp,ebp
pop ebp
ret 16

FindDataInBuffer_FOUND:
	mov eax,edx
jmp FindDataInBuffer_EXIT

;=================================================================
IsValidClass:	 ;[esp+4] = pointer to class name
;=================================================================

;!!!!!!!!!!!!!!!!!!!! INSTEAD CAN JUST CHECK SOME PASSED POINTER WITH POINTERS IN LIST

;returns true or false in eax and class index in ecx (or -1)

push esi
       mov esi,[esp+8]
push ebx
       mov al,[esi]
push ebp

       cmp al,'C'
	   jz IsValidClass_ENTER
       cmp al,'T'		;TPartitionList
	   jz IsValidClass_ENTER
       cmp al,'t'		;type_info
	   jz IsValidClass_ENTER
       jmp IsValidClassNO
       IsValidClass_ENTER:

       mov ebp,[classnameslpbuf]
       xor ebx,ebx
       IsValidClass_LOOP:
       mov edx,[ebx+ebp]
       add edx,4
       invoke lstrcmp,esi,edx
       test eax,eax
	    jz IsValidClassYES
       add ebx,4
       cmp ebx,[classindex]
	   jb IsValidClass_LOOP

IsValidClassNO:
       xor eax,eax
       mov ecx,-1
pop ebp
pop ebx
pop esi
ret 4

IsValidClassYES:
	mov eax,TRUE
	mov ecx,ebx
pop ebp
pop ebx
pop esi
ret 4




;=================================================================
			include 'GETLABELS.inc'
;=================================================================

;=================================================================
section '.data' data readable writeable
;=================================================================

sourceexeread2		dd	0
sourceexereadend2	dd	0
sourceexeread_size2	dd	0
classcount2		dd	0
destfileexedatahandle	dd	0

tresclasses		db	"tresclasses.inc",0
tresvtbasedataext	db	"tresvtbasedataext.inc",0
exevtablesp611		db	"exevtablesp611.inc",0
exename_p611		db	"P611.exe",0

msgbox_caption		db	"CLVT For Trespasser",0

EMPTY_STRING		db	0
SPACE_STRING		db	" ",0

customstructemplate:
db 0Dh,0Ah
db "customstruc %s",0Dh,0Ah
db "   ;inherits: %s",0Dh,0Ah
db "            .lpVTable               dd ?",0Dh,0Ah
db "endcs",0Dh,0Ah,0Dh,0Ah

db "   ;VTable Methods (%u total)",0Dh,0Ah
db "   customstruc %sVTM",0Dh,0Ah
db "               .Release                dd ?",0Dh,0Ah
db "        strucsize %u",0Dh,0Ah
db "   endcs",0Dh,0Ah,0Dh,0Ah
db 0

searchstr_avc	     db      ".?AV"
searchstr_at	     db      "@"
searchstr_atat	     db      "@@"
searchstr_0	     db      0

source_exe_handle    dd      0
source_exe_read      dd      0
source_read_size     dd      0
source_end_read_buf  dd      0

classnameslpbuf      dd      0
classnamesizebuf     dd      0
vtablelengthsbuf     dd      0
vtablesuboneaddrbuf  dd      0
classindex	     dd      0

currADDR	     dd      0
currADDRvalue	     dd      0
currADDRSUB	     dd      0
currADDRSUBvalue     dd      0

temp_buf	     db      4000 dup 0
temp_buf2	     db      2000 dup 0
temp_buf3	     db      2000 dup 0

temp_var	     dd      0
dest_txt_handle      dd      0

rdata_section_offset dd      0
data_section_end     dd      0
code_section_size    dd      0

filesize		dd	0
byteswritten		dd	0

error_success_1      db      "File scanned.",0


;=================================================================
;NEW--------------------------------------------------------
;=================================================================

interfacetemplateheader:
db "// ATX Trespasser 2.00+ Plugin System",0Dh,0Ah
db "// Trespasser Class VTable Interface Structures",0Dh,0Ah
interfacetemplateheader_end:
db 0

no_string	db	0


interfacestemplatestart:
db 0Dh,0Ah
db "typedef struct %s %s%s%s{ // %u methods total",0Dh,0Ah    ;third %s is series of calculated space characters for tabs
db 0

interfacestemplatemember:
db "               void *%s; %-30s// 0x%.3X",0Dh,0Ah
db 0

interfacestemplateend:
db "        } %s;",0Dh,0Ah
db 0

interfacesinheritkeyword:
db ": public "
db 0


interfaces_filehandle	dd	0
interfaces_filename	db	"tresclassinterfaces.inc",0
vtablestempbuffer	dd	0

;=================================================================
;Label import data
;=================================================================

import_filename 	db	"sourcelabels.ini",0

tempunknownmethodcounter	dd	0	;NOT NEEDED: use vtable offsets in names instead

hex_print_string	db	"0x%.8X",0
hex_short_print_string	db	"0x%.4X",0
Label_key_string	db	"Label",0
label_Release		db	"Unknown_0000",0
string_0		db	"0",0
unknownmethod_print_string	db	"Unknown_%.4X",0

module_handle		dd	0

currentprocessnamebuffer	db	512 dup 0

TRESCLASSESCREATELOOP_RUNONCE	db	0
CURRENT_INHERITANCE_COUNT	dd	0

;=================================================================
section '.idata' import data readable writeable
;=================================================================
  library kernel,'KERNEL32.DLL',\
	  user,'USER32.DLL',\
	  comdlg,'COMDLG32.DLL'


  import kernel,\
	 CloseHandle,"CloseHandle",\
	 CreateFile,"CreateFileA",\
	 ExitProcess,"ExitProcess",\
	 GetFileSize,"GetFileSize",\
	 GetModuleFileName,"GetModuleFileNameA",\
	 GetModuleHandle,"GetModuleHandleA",\
	 GetPrivateProfileInt,"GetPrivateProfileIntA",\
	 GetPrivateProfileSection,"GetPrivateProfileSectionA",\
	 GetPrivateProfileSectionNames,"GetPrivateProfileSectionNamesA",\
	 GetPrivateProfileString,"GetPrivateProfileStringA",\
	 LocalAlloc,"LocalAlloc",\
	 LocalFree,"LocalFree",\
	 lstrcmp,"lstrcmpA",\
	 ReadFile,"ReadFile",\
	 SetFilePointer,'SetFilePointer',\
	 WriteFile,'WriteFile'

  import user,\
	 MessageBox,'MessageBoxA',\
	 wsprintf,"wsprintfA"

  import comdlg,\
	 GetOpenFileName,'GetOpenFileNameA'

;=================================================================
section '.rsrc' resource data readable
;=================================================================

	directory RT_VERSION,versions

	resource versions,\
	   1,LANG_NEUTRAL,version

	versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,\
				LANG_ENGLISH+SUBLANG_DEFAULT,0,\
	  'FileDescription','CLVT For Trespasser',\
	  'LegalCopyright','Free, open source.',\
	  'FileVersion',VTABLEIDVERSION,\
	  'ProductVersion',VTABLEIDVERSION,\
	  'OriginalFilename','CLVT.exe'

