;============================================================
; This will modify the executable once loaded, but doesn't save changes.
; Uses GetCurrentProcessId,OpenProcess,WriteProcessMemory to write
; new code into executable. Now also uses VirtualProtectEx for
; write access for picky OSes.
;============================================================

; create log file in base Tres folder (by Windows defaults)

	stdcall CreateLogFile,atxlogfilepath_const,_log_title,_log_title.size

; detect EXE and load ATXconfig.ini

	include 'integrated\exedetection.inc'
	include 'integrated\filepaths.inc'

; read ATXconfig.ini and update if incomplete

	call ReadAllATXConfigValues

; retrieve misc. system info

	invoke GetSystemInfo,system_info_buf
	invoke GetProcessHeap
	mov [processheaphandle],eax

; unprotect Tres EXE sections

	include 'integrated\sectionsunprotect.inc'	; NO VIRTUALPROTECT[EX] CALLS BEFORE THIS POINT!!!!

; intercept Trespasser EXE exit function pointers

	include 'integrated\exitprocsintercept.inc'

; initialize console (must be before other cheat addons)

	include 'integrated\consoleinitbegin.inc'

; set up hotkeys (scan from ATXconfig.ini)

	call INI_CHECKNEWHOTKEYSINITPROC

; scan for optional INI entries

	mov eax,CAnimalObjValLocInfoTable
	mov edx,section_canimaldisplay
	call INI_CHECKNEWOBJVALDISPLAYSINITPROC 	; CAnimal display options

; update ATXconfig.ini if necessary (before dest. variables are modified in codeinit)

	;BBMCALLINV UpdateAllATXConfigINIValues,[ATXConfigComplete]
	call UpdateAllATXConfigINIValues

