;===============================================================
; DETECTS CALLING EXECUTABLE AND SETS CURRENT DIRECTORY PATH
;===============================================================

	invoke GetModuleFileName,0,trespassexepath_const,MAX_PATH
	mov [trespassexepathlength],eax 		; save path length (excluding null-terminator)
	xor ebp,ebp

	test eax,eax
	jnz @f

		or ebp,1

	@@:

	WRITELOG _message22b,ebp,WRITELOG_EXIT

; open main EXE to get size
; FILE_SHARE_READ required to get handle, else fails

	invoke CreateFile,trespassexepath_const,GENERIC_READ,FILE_SHARE_READ,\
			  0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	mov ebp,1
	cmp eax,-1
	jz .getexesizeerror

	test eax,eax
	jz .getexesizeerror

	xor ebp,ebp

	push eax
	invoke GetFileSize,eax,0
	pop ecx

	cmp eax,-1
	jnz @f

		mov ebp,1

	@@:

.getexesizeerror:

	WRITELOG _message22c,ebp,WRITELOG_EXIT

	push eax
	invoke CloseHandle,ecx
	pop eax

	cmp eax,P511_SIZE
	jz .setp511

	cmp eax,DEMO_SIZE				; detect executable type via file size
	jz .setdemo

	cmp eax,P611_SIZE
	jz .setp611

	cmp eax,K611_SIZE
	jz .setk611

	WRITELOG _message22,1,WRITELOG_FORCEEXIT

; set proper base BaseData addresses

.setk611:

	mov esi,K6_1_1_Data
	jmp .exeset

.setp611:

	mov esi,P6_1_1_Data
	jmp .exeset

.setdemo:

	mov esi,P5_Demo_Data

.exeset:

	mov edi,EXE_Specific_BaseData_MAIN
	mov ecx,(BaseData_MAIN_END-EXE_Specific_BaseData_MAIN)/4
	rep movsd

.setp511:						; default EXE (no address transfer required)

	mov eax,[EXEID]
	mov DWORD [LOGEXETYPE],eax
	WRITELOG _message22,0





