@echo off
echo ATX Compilation Script for ATYPEX.dll
echo.
echo This attempts to compile ATYPEX.dll. If succeeds, generates 
echo text symbols file and copies to predefined locations
echo (see individual batch files for exact behavior).
echo.
echo REQUIRES FASM.EXE AND SYMBOLS.EXE 
echo FROM FASM 1.68 IN SYSTEM PATH ENVIRONMENT VARIABLE.
echo.
echo ===========================
echo Re-generating include files...
echo ===========================
echo.
call includegenerator
echo.
echo ===========================
echo Compiling...
echo ===========================
echo.
call compiledll
if %ERRORLEVEL%==0 goto success
echo.
echo Compilation failed.
echo.
goto skipsuccess
:success
echo.
echo Compilation successful.
echo.
echo ===========================
echo Generating text symbols...
echo ===========================
echo.
call symbols
echo.
echo ===========================
echo Copying DLL to predefined locations...
echo ===========================
echo.
@echo on
call copydll
@echo off
echo.
echo All finished.
echo.
:skipsuccess
pause