
;============================================================
proc RTTIGetTresClassNumBaseClasses lpSourceClassVTable
;============================================================

	mov eax,[lpSourceClassVTable]
	mov eax,[eax-4]
	mov eax,[eax+RTTICompleteObjectLocator.pClassDescriptor]
	mov eax,[eax+RTTIClassHierarchyDescriptor.numBaseClasses]

ret
endp

;============================================================
proc RTTIReplicateInheritanceShallow uses esi edi ebx,SourceClassVT,lpMem,lpTypeInfo
;============================================================
; lpMem should be (sizeof.RTTIShallow + numBaseClasses*4 + 4) bytes

	mov ebx,[lpMem]
	mov eax,[SourceClassVT]

  ; RTTICompleteObjectLocator

	mov esi,[eax-4]

	mov eax,[esi+RTTICompleteObjectLocator.signature]
	mov ecx,[esi+RTTICompleteObjectLocator.offset]
	mov edx,[esi+RTTICompleteObjectLocator.cdOffset]

	mov [ebx+RTTIShallow.COL.signature],eax
	mov [ebx+RTTIShallow.COL.offset],ecx
	mov [ebx+RTTIShallow.COL.cdOffset],edx

	mov edx,[lpTypeInfo]
	lea ecx,[ebx+RTTIShallow.CHD]
	mov [ebx+RTTIShallow.COL.pTypeDescriptor],edx
	mov [ebx+RTTIShallow.COL.pClassDescriptor],ecx


  ; RTTIClassHierarchyDescriptor

	mov esi,[esi+RTTICompleteObjectLocator.pClassDescriptor]

	mov eax,[esi+RTTIClassHierarchyDescriptor.signature]
	mov edx,[esi+RTTIClassHierarchyDescriptor.attributes]
	mov ecx,[esi+RTTIClassHierarchyDescriptor.numBaseClasses]
	mov [ebx+RTTIShallow.CHD.signature],eax
	mov [ebx+RTTIShallow.CHD.attributes],edx
	mov [ebx+RTTIShallow.CHD.numBaseClasses],ecx		; ecx = numBaseClasses

	lea edx,[ebx+sizeof.RTTIShallow]
	mov [ebx+RTTIShallow.CHD.pBaseClassArray],edx


  ; Base Class Array

	mov esi,[esi+RTTIClassHierarchyDescriptor.pBaseClassArray]

	push esi
     ; here, ecx = numBaseClasses already
	lea edi,[ebx+sizeof.RTTIShallow]
	rep movsd
	pop esi
	mov DWORD [edi],0				; padding

	lea ecx,[ebx+RTTIShallow.BCD]
	mov [ebx+sizeof.RTTIShallow],ecx		; first array member replaced

  ; RTTIBaseClassDescriptor

	mov esi,[esi]

	mov eax,[esi+RTTIBaseClassDescriptor.numContainedBases]
	mov ecx,[esi+RTTIBaseClassDescriptor.where.mdisp]
	mov edx,[esi+RTTIBaseClassDescriptor.where.pdisp]
	mov [ebx+RTTIShallow.BCD.numContainedBases],eax
	mov [ebx+RTTIShallow.BCD.where.mdisp],ecx
	mov [ebx+RTTIShallow.BCD.where.pdisp],edx
	mov eax,[esi+RTTIBaseClassDescriptor.where.vdisp]
	mov ecx,[esi+RTTIBaseClassDescriptor.attributes]
	mov edx,[lpTypeInfo]
	mov [ebx+RTTIShallow.BCD.where.vdisp],eax
	mov [ebx+RTTIShallow.BCD.attributes],ecx
	mov [ebx+RTTIShallow.BCD.pTypeDescriptor],edx

ret
endp


;============================================================
proc RTTIReplicateTypeInfoShallow uses esi edi, SourceClassVT,lpMem,lpMangledName
;============================================================
; lpMem should be (sizeof.type_info + (lpMangledName string length) + DWORD alignment + 4) bytes

	mov eax,[SourceClassVT]
	mov eax,[eax-4]
	mov esi,[eax+RTTICompleteObjectLocator.pTypeDescriptor]

	mov edi,[lpMem]
	mov ecx,sizeof.type_info
	rep movsb

	mov esi,[lpMangledName]
	call TransferString

	inc edi
	mov edx,edi
	xor eax,eax

	sub edx,[lpMem]
	mov ecx,4
	and edx,3
	sub ecx,edx
	and ecx,3
	rep stosb		; padd with null-bytes to DWORD
	mov [edi],eax		; dummy padding

ret
endp
