;==========================================================
ATXPROC FOLLOWDINOCHEATTOGGLE_PROC
;==========================================================
; [esp+4] = FD_fetch function
; Will only toggle FOLLOWDINO state off
; if FD_fetch function is same as before
; This is so that the same feature that last used FOLLOWDINO
; must be re-used to disable it before another feature uses it.

	cmp [THIRDPEnabled],1
	    jz .exit
	cmp [FlyModeEnabled],1
	    jz .exit

	cmp [FDEnabled],TRUE
	    jz .disable

	GETCCAMERAINSTANCE edx

	xor eax,eax
	mov ecx,[edx+50h]
	mov [edx+50h],eax
	mov [FDPrevCamObj1],ecx

	mov ecx,[edx+54h]
	mov [edx+54h],eax
	mov [FDPrevCamObj2],ecx

	call DisableInGameKeys
	mov [DisableInGameMouseMvt],TRUE

	invoke GetTickCount
	mov edx,[esp+4]
	mov [FDTickCountInput],eax
	mov [FDFetchFunction],edx
	mov [FDEnabled],TRUE

.exit:
ret 4

.disable:

	mov eax,[esp+4]
	cmp eax,[FDFetchFunction]			; must have same function to disable!
	    jnz .exit

	GETCCAMERAINSTANCE edx
	mov [FDEnabled],0

	mov eax,[FDPrevCamObj1]
	mov ecx,[FDPrevCamObj2]
	mov [edx+50h],eax				; replace original camera object
	mov [edx+54h],ecx

	mov [DisableInGameMouseMvt],FALSE
	call EnableInGameKeys

ret 4