;===========================================================
ATXPROC OBJCHEATTOGGLE_PROC
;===========================================================
; esi points to object address string
; if esi is null (or if instance invalid), turns off OBJ cheat
; if edx is not null, value in edx is used instead of esi string

push ebx

	test esi,esi
	     jz .disable
	test edx,edx
	mov [ObjCheatCurrentObjectTemp],edx
	     jnz .noobjstringscan

	cinvoke sscanf,esi,HEX_STR,ObjCheatCurrentObjectTemp
	.noobjstringscan:

	mov ebx,[ObjCheatCurrentObjectTemp]
	test ebx,ebx
	     jz .error

	invoke IsBadReadPtr,ebx,050h			; base object class (variable size, at least 050h for position/orientation values)
	test eax,eax
	     jnz .error

	mov ebx,[ebx+28h]
	invoke IsBadReadPtr,ebx,8			; first sub-object
	test eax,eax
	     jnz .error

	mov ebx,[ebx+0Ch]
	invoke IsBadReadPtr,ebx,8			; second sub-object (main)
	test eax,eax
	     jnz .error

	mov eax,[ObjCheatCurrentObjectTemp]
	mov ebx,[eax]
	invoke IsBadReadPtr,ebx,8			; object VTable
	test eax,eax
	     jnz .error

	mov [ObjCheatClassTypeStr],ObjOutput_Err_2_STR	; set initial class type (none)
	sub ebx,4
	invoke IsBadReadPtr,ebx,8			; address of object VTable member [-4h] (debug info pointer(?))
	test eax,eax
	     jnz .noclasstype

	mov ebx,[ebx]
	invoke IsBadReadPtr,ebx,14h			; object VTable member [-4h] itself (debug info pointer(?))
	test eax,eax
	     jnz .noclasstype

	mov ebx,[ebx+0Ch]
	invoke IsBadReadPtr,ebx,8			; debug info member [+0Ch]
	test eax,eax
	     jnz .noclasstype

	add ebx,12
	invoke IsBadStringPtr,ebx,256			; Class type string
	test eax,eax
	     jnz .noclasstype

	mov [ObjCheatClassTypeStr],ebx

	.noclasstype:

	mov eax,[ObjCheatCurrentObjectTemp]
	mov [OBJNInstance],eax
	mov [ObjCheatCurrentObject],eax
	mov [UseOBJAIMFunction],0
	mov [UseObjCheat],1

pop ebx
ret

.error:

	SHOWTEMPMESSAGE OBJ_INPUT_ERROR1_STR

pop ebx
ret

.disable:

	mov [UseObjCheat],0

pop ebx
ret