;============================================================
ATXPROC DISPLAYOBJCHEAT
;============================================================
push ebp

	GETDDSURFACEDC

	mov ebx,stack_ext_buffer
	mov ebp,OBJ_CHEAT_MSG

; check for OBJAIM

	cmp [UseOBJAIMFunction],0
	    jz .noobjaim
	mov ecx,[THIRDPAIMAimdotLastObj]
	test ecx,ecx
	     jnz .objaimenabled

	invoke TextOut,edi,0,ebp,\
	       ObjAim_NoObject_STR,ObjAim_NoObject_STR.size
	add ebp,OBJ_CHEAT_MSG_INTERVAL
	jmp .exit

	.objaimenabled:
	mov [ObjCheatCurrentObject],ecx
	mov eax,[ecx]	;VTable
	mov ecx,[eax-4]
	mov edx,[ecx+0Ch]
	add edx,12
	mov [ObjCheatClassTypeStr],edx

	.noobjaim:

; print object address

	cinvoke sprintf,ebx,ObjOutput_1_STR,[ObjCheatCurrentObject]
	invoke TextOut,edi,0,ebp,ebx,eax
	add ebp,OBJ_CHEAT_MSG_INTERVAL

; print object name hash (CRC32)

	mov eax,[ObjCheatCurrentObject]
	cinvoke sprintf,ebx,ObjOutput_1b_STR,[eax+CInstance.InstanceNameID]
	invoke TextOut,edi,0,ebp,ebx,eax
	add ebp,OBJ_CHEAT_MSG_INTERVAL


; retrieve object velocity & "rotational velocity"

	GETINSTANCEVELOCITYVALUES (stack_ext_buffer+400),[ObjCheatCurrentObject]

; print velocity (vector)

	fld DWORD [eax+8]
	fld DWORD [eax+4]
	fld DWORD [eax]
	sub esp,24
	fstp QWORD [esp]
	fstp QWORD [esp+8]
	fstp QWORD [esp+16]
	invoke sprintf,ebx,ObjOutput_2_STR
	add esp,(24+8)
	invoke TextOut,edi,0,ebp,ebx,eax
	add ebp,OBJ_CHEAT_MSG_INTERVAL

; print velocity (total value)

	mov eax,(stack_ext_buffer+400)
	call VectorMagnitude_st0
	sub esp,8
	fstp QWORD [esp]
	invoke sprintf,ebx,ObjOutput_2b_STR
	add esp,(8+8)
	invoke TextOut,edi,0,ebp,ebx,eax
	add ebp,OBJ_CHEAT_MSG_INTERVAL

; print "rotational velocity"

	mov eax,(stack_ext_buffer+400+12)
	fld DWORD [eax+12]
	fld DWORD [eax+8]
	fld DWORD [eax+4]
	fld DWORD [eax]
	sub esp,32
	fstp QWORD [esp]
	fstp QWORD [esp+8]
	fstp QWORD [esp+16]
	fstp QWORD [esp+24]
	invoke sprintf,ebx,ObjOutput_3_STR
	add esp,(32+8)
	invoke TextOut,edi,0,ebp,ebx,eax
	add ebp,OBJ_CHEAT_MSG_INTERVAL

; print location

	mov edx,[ObjCheatCurrentObject]
	fld DWORD [edx+38h]
	fld DWORD [edx+34h]
	fld DWORD [edx+30h]
	sub esp,24
	fstp QWORD [esp]
	fstp QWORD [esp+8]
	fstp QWORD [esp+16]
	invoke sprintf,ebx,ObjOutput_4_STR
	add esp,(24+8)
	invoke TextOut,edi,0,ebp,ebx,eax
	add ebp,OBJ_CHEAT_MSG_INTERVAL

; print distance from player

	mov edx,[ObjCheatCurrentObject]
	GETCPLAYERPRIVINSTANCE ecx
	call GetDistanceBetweenInstances
	sub esp,8
	fstp QWORD [esp]
	invoke sprintf,ebx,ObjOutput_4b_STR
	add esp,16
	invoke TextOut,edi,0,ebp,ebx,eax
	add ebp,OBJ_CHEAT_MSG_INTERVAL

; print orientation (quaternion)

	mov edx,[ObjCheatCurrentObject]
	fld DWORD [edx+48h]
	fld DWORD [edx+44h]
	fld DWORD [edx+40h]
	fld DWORD [edx+3Ch]
	sub esp,32
	fstp QWORD [esp]
	fstp QWORD [esp+8]
	fstp QWORD [esp+16]
	fstp QWORD [esp+24]
	invoke sprintf,ebx,ObjOutput_5_STR
	add esp,(32+8)
	invoke TextOut,edi,0,ebp,ebx,eax
	add ebp,OBJ_CHEAT_MSG_INTERVAL

; print orientation ("Facing" vector)

	mov edx,[ObjCheatCurrentObject]
	push 0
	lea ecx,[edx+3Ch]
	push (stack_ext_buffer+400)
	call CONVERT_TO_FACING_PROC_010 			; (ATX-optimized version of the same EXE proc)

	mov eax,(stack_ext_buffer+400)
	fld DWORD [eax+8]
	fld DWORD [eax+4]
	fld DWORD [eax]
	sub esp,24
	fstp QWORD [esp]
	fstp QWORD [esp+8]
	fstp QWORD [esp+16]
	invoke sprintf,ebx,ObjOutput_6_STR
	add esp,(24+8)
	invoke TextOut,edi,0,ebp,ebx,eax
	add ebp,OBJ_CHEAT_MSG_INTERVAL

; print object class type

	cinvoke sprintf,ebx,ObjOutput_7_STR,[ObjCheatClassTypeStr]
	cmp eax,1
	    jle .noprintclasstype

	lea edx,[ebx+eax]
	cmp WORD [edx-2],'@@'
	    jnz @f
	    sub eax,2
	@@:

	invoke TextOut,edi,0,ebp,ebx,eax
	add ebp,OBJ_CHEAT_MSG_INTERVAL
	.noprintclasstype:


; print mesh type if present

	mov eax,[ObjCheatCurrentObject]
	mov esi,[eax+CInstance.lpCInfo]
	stdcall IsValidInstance,esi,20
	test eax,eax
	     jz .noprintmeshtype
	mov eax,[esi]
	cmp eax,[CINFOVTABLE]
	    jnz .noprintmeshtype

	mov eax,[esi+8] 					; CRenderType object
	mov eax,[eax]
	mov edx,[eax-4]
	mov ecx,[edx+0Ch]
	add ecx,12

	cinvoke sprintf,ebx,ObjOutput_8_STR,ecx
	cmp eax,1
	    jle .noprintmeshtype

	lea edx,[ebx+eax]
	cmp WORD [edx-2],'@@'
	    jnz @f
	    sub eax,2
	@@:

	invoke TextOut,edi,0,ebp,ebx,eax
	add ebp,OBJ_CHEAT_MSG_INTERVAL

; print CTexture reference count for mesh (if applicable)

	mov esi,[esi+8] 					; CMesh object
	mov ecx,[esi]
	mov edx,[CMESHVTABLE]
	call IsTresClassInheritor				; MUST CHECK IF INHERITS CMESH
	test eax,eax
	     jz .noprintmeshtype

	cinvoke sprintf,ebx,ObjOutput_9_STR,[esi+18h]
	invoke TextOut,edi,0,ebp,ebx,eax
	add ebp,OBJ_CHEAT_MSG_INTERVAL

	cinvoke sprintf,ebx,ObjOutput_A_STR,[esi+28h]
	invoke TextOut,edi,0,ebp,ebx,eax
	add ebp,OBJ_CHEAT_MSG_INTERVAL

	cinvoke sprintf,ebx,ObjOutput_B_STR,[esi+38h]
	invoke TextOut,edi,0,ebp,ebx,eax
	add ebp,OBJ_CHEAT_MSG_INTERVAL

	.noprintmeshtype:

.exit:

	RELEASEDDSURFACEDC

pop ebp
ret