;====================================================================
ATINITPROC _AT103Init
;====================================================================

; get Axx instances until not found, starting with A00

	xor ebx,ebx
	mov esi,stack_ext_buffer
	call ReadAxxNameIDArray

	mov esi,eax						; esi = number of potential gun instances
	lea edx,[eax*4+sizeof.CAT103]

; create main AT103 instance

	ALLOCATBASE edx,AT103					; size = 32 + 4*number of gun instances

	mov [edi+CAT103.Ammo],AT103_NO_AMMO_VALUE
	mov [edi+CAT103.AltAmmoCount],ecx
	    inc ecx
	mov [edi+CAT103.ReloadsLeft],AT103_INFINITE_RELOADS
	mov [edi+CAT103.TargetWeapons],ecx
	mov [edi+CAT103.NumberOfAllowedGuns],esi		; instance count (0 if apply to all)

; copy instances to AT103 instance (if any)

	test esi,esi
	jz .noinstances

		push edi
		mov ecx,esi
		mov esi,stack_ext_buffer
		add edi,sizeof.CAT103
		rep movsd
		pop edi

	.noinstances:

; get other reload values

	inc ebx
	GETSETVALUEDIR TSCRIPT_OFFSETVALUE_AMMO,ebx,TSCRIPT_VALUETYPE_INT,CAT103.Ammo

	inc ebx
	GETSETVALUEDIR TSCRIPT_OFFSETVALUE_ALTAMMOCOUNT,ebx,TSCRIPT_VALUETYPE_INT,CAT103.AltAmmoCount

	inc ebx
	GETSETVALUEDIR TSCRIPT_OFFSETVALUE_LOOPCOUNT,ebx,TSCRIPT_VALUETYPE_INT,CAT103.ReloadsLeft

	inc ebx
	GETSETVALUEDIR TSCRIPT_OFFSETVALUE_FRAME,ebx,TSCRIPT_VALUETYPE_INT,CAT103.TargetWeapons

	mov eax,[edi+CAT103.ReloadsLeft]
	mov [edi+CAT103.InitialTotalReloads],eax

	jmp ExitINAT
