;====================================================================
ATINITPROC _AT119Init
;====================================================================

	ALLOCATBASE sizeof.CAT119,AT119

	mov [edi+CAT119.Flags],ecx
	mov [edi+CAT119.NewState],-1

	push edi
	lea edi,[edi+CAT119.NewEffect]
	xor eax,eax
	mov ecx,(sizeof.RainEffectBase)/4
	rep stosd
	pop edi


; state = TSCRIPT_OFFSETVALUE_FRAME
; xpos = TSCRIPT_OFFSETVALUE_RADIUS
; zneg = TSCRIPT_OFFSETVALUE_ZFREE
; zpos = TSCRIPT_OFFSETVALUE_ZTFREE
; dropgroupinterval = TSCRIPT_OFFSETVALUE_INTERVAL
; particlesperdropgroup = TSCRIPT_OFFSETVALUE_LOOPCOUNT
; effectnameid = TSCRIPT_OFFSETVALUE_SAMPLE
; threshold = TSCRIPT_OFFSETVALUE_SAMPLE
; param7 = TSCRIPT_OFFSETVALUE_DENSITY

	GETSETVALUEDIR TSCRIPT_OFFSETVALUE_FRAME,0,TSCRIPT_VALUETYPE_INT,CAT119.NewState

	cmp [edi+CAT119.NewState],-1
	jz @f

		or [edi+CAT119.Flags],AT119_STATE_CHANGE

	@@:


	GETSETVALUERET TSCRIPT_OFFSETVALUE_SAMPLE,1,TSCRIPT_VALUETYPE_STRING
	test eax,eax
	jz ExitINAT

	ccall [CParticlesEncodeNameProc],eax
	test eax,eax
	jz ExitINAT

	or [edi+CAT119.Flags],AT119_EFFECT_CHANGE
	mov [edi+CAT119.NewEffect.EffectNameID],eax

	GETSETVALUEDIR TSCRIPT_OFFSETVALUE_RADIUS	,2,TSCRIPT_VALUETYPE_FLOAT,	CAT119.NewEffect.Area.XPos
	GETSETVALUEDIR TSCRIPT_OFFSETVALUE_ZFREE	,3,TSCRIPT_VALUETYPE_FLOAT,	CAT119.NewEffect.Area.ZNeg
	GETSETVALUEDIR TSCRIPT_OFFSETVALUE_ZTFREE	,4,TSCRIPT_VALUETYPE_FLOAT,	CAT119.NewEffect.Area.ZPos
	GETSETVALUEDIR TSCRIPT_OFFSETVALUE_INTERVAL	,5,TSCRIPT_VALUETYPE_INT,	CAT119.NewEffect.DropGroupInterval
	GETSETVALUEDIR TSCRIPT_OFFSETVALUE_NUMBER	,6,TSCRIPT_VALUETYPE_INT,	CAT119.NewEffect.ParticlesPerDropGroup
	GETSETVALUEDIR TSCRIPT_OFFSETVALUE_SAMPLE	,7,TSCRIPT_VALUETYPE_FLOAT,	CAT119.NewEffect.ParticleThreshold
	GETSETVALUEDIR TSCRIPT_OFFSETVALUE_DENSITY	,8,TSCRIPT_VALUETYPE_FLOAT,	CAT119.NewEffect.ParticleParam7

	jmp ExitINAT
