;===============================================================
; DEFAULT GLOBAL CLUT VALUES INTERCEPT/OVERRIDE
;===============================================================

;===============================================================
INTERCEPTPROC GLOBALCLUTDEFAULTINTERCEPT		; eax,ecx,edx may be destroyed
;===============================================================
; NOTE: This function is called multiple times, but this does
; not affect global clut values retrieved because it is never
; called near the end of loading (where they are modified).

	cmp [NIGHTEnabled],0
	    jz .nointercept

	mov eax,[GLOBALCLUTSTARTTEMPADDR]
	mov edx,[GLOBALCLUTSTOPTEMPADDR]

; set new clut values

	mov ecx,[NIGHTDefaultGlobalClutStart]
	mov [eax],ecx
	mov ecx,[NIGHTDefaultGlobalClutStop]
	mov [edx],ecx

.nointercept:

;/* REPLACED CODE
	mov edx,[GLOBALCLUTSTOPTEMPADDR]
	mov edx,[edx]
;*/
ret

