;========================================================
; ATX 3DNOW/SSE OPTIMIZATION-RELATED DATA
;========================================================

align 4

; function calls
; first function = std function
; second function = 3DNow! equivalent (null if not implemented)

PTRPROCTABLESTART:

PTRQuaternionMul			dd	QuaternionMul_STD,			QuaternionMul_3DNOW,			0
PTRToLocalQuat_AxisX			dd	ToLocalQuat_AxisX_STD,			0,					0
PTRToLocalQuat_AxisY			dd	ToLocalQuat_AxisY_STD,			0,					0
PTRToLocalQuat_AxisZ			dd	ToLocalQuat_AxisZ_STD,			0,					0
PTRToLocalQuat_AxisX_NoNorm		dd	ToLocalQuat_AxisX_NoNorm_STD,		0,					0
PTRToLocalQuat_AxisY_NoNorm		dd	ToLocalQuat_AxisY_NoNorm_STD,		0,					0
PTRToLocalQuat_AxisZ_NoNorm		dd	ToLocalQuat_AxisZ_NoNorm_STD,		0,					0
PTRQuatToAxisAngle			dd	QuatToAxisAngle_STD,			0,					0
PTRNormalizeQuat			dd	NormalizeQuat_STD,			NormalizeQuat_3DNOW,			0
PTRCONVERT_TO_FACING_PROC_2A		dd	CONVERT_TO_FACING_PROC_2A_STD,		0,					0
PTRCONVERT_TO_FACING_PROC_010		dd	CONVERT_TO_FACING_PROC_010_STD, 	CONVERT_TO_FACING_PROC_3DNOW_010,	0
PTRVectorDotProduct			dd	VectorDotProduct_STD,			0,					0
PTRFDConvAnglesToQuat			dd	FDConvAnglesToQuat_STD, 		0,					0
PTRFacingRad2CompToVector_Sub		dd	FacingRad2CompToVector_Sub_STD, 	0,					0
PTRToLocalQuat_NoNorm			dd	ToLocalQuat_NoNorm_STD, 		0,					0
PTRVectorNormalize			dd	VectorNormalize_STD,			VectorNormalize_3DNOW,			0
PTRQuaternionMulLocalQ2AxisX		dd	QuaternionMulLocalQ2AxisX_STD,		QuaternionMulLocalQ2AxisX_3DNOW,	0
PTRVectorMagnitude			dd	VectorMagnitude_STD,			0,					0
PTRVectorToQuaternion			dd	VectorToQuaternion_STD, 		0,					0
PTRToLocalQuat_AxisMinusX_NoNorm	dd	ToLocalQuat_AxisMinusX_NoNorm_STD,	0,					0
PTRToLocalQuat_AxisMinusY_NoNorm	dd	ToLocalQuat_AxisMinusY_NoNorm_STD,	0,					0
PTRToLocalQuat_AxisMinusZ_NoNorm	dd	ToLocalQuat_AxisMinusZ_NoNorm_STD,	0,					0
PTRObjVectorDisplace			dd	0,					0,					0	; ObjVectorDisplace_SSE

PTRPROCTABLEEND:
