;============================================================
ATXPROC FindFirstDWORDListMatch 	; param1 = list1, param2=list2
;============================================================
; compares two list of DWORDS and returns the first value
; that comes up in both list1 and list2, where list1 values
; have priority. Both lists must be null-terminated (by DWORD 0).
; If no match found, implicitly returns 0.

	mov ecx,[esp+4]
	mov edx,[esp+8]

	cmp DWORD [ecx],0
	    jz .notfound
	cmp DWORD [edx],0
	    jz .notfound

	.list1loop:
	mov eax,[ecx]

	    mov edx,[esp+8]
	    .list2loop:
	    cmp eax,[edx]
		jz .found
	    add edx,4
	    cmp DWORD [edx],0
		jnz .list2loop

	add ecx,4
	cmp DWORD [edx],0
	    jnz .list1loop

	.notfound:
	xor eax,eax
	.found:

ret 8
