
; GENERIC

macro MAKE_HRESULT hresultlabel,sev,fac,code {
      hresultlabel equ ((sev shl 31) + (fac shl 16) + code)	; should be '=' instead of 'equ'?
    }

; DIRECTDRAW

_FACDD							equ		0x876

macro MAKE_DDHRESULT hresultlabel,code {
      MAKE_HRESULT hresultlabel,1,_FACDD,code
}

; Error codes

D3D_OK							equ		0	; DD_OK

MAKE_DDHRESULT D3DERR_BADMAJORVERSION,			700
MAKE_DDHRESULT D3DERR_BADMINORVERSION,			701
MAKE_DDHRESULT D3DERR_INVALID_DEVICE,			705
MAKE_DDHRESULT D3DERR_INITFAILED,			706
MAKE_DDHRESULT D3DERR_DEVICEAGGREGATED, 		707
MAKE_DDHRESULT D3DERR_EXECUTE_CREATE_FAILED,		710
MAKE_DDHRESULT D3DERR_EXECUTE_DESTROY_FAILED,		711
MAKE_DDHRESULT D3DERR_EXECUTE_LOCK_FAILED,		712
MAKE_DDHRESULT D3DERR_EXECUTE_UNLOCK_FAILED,		713
MAKE_DDHRESULT D3DERR_EXECUTE_LOCKED,			714
MAKE_DDHRESULT D3DERR_EXECUTE_NOT_LOCKED,		715
MAKE_DDHRESULT D3DERR_EXECUTE_FAILED,			716
MAKE_DDHRESULT D3DERR_EXECUTE_CLIPPED_FAILED,		717
MAKE_DDHRESULT D3DERR_TEXTURE_NO_SUPPORT,		720
MAKE_DDHRESULT D3DERR_TEXTURE_CREATE_FAILED,		721
MAKE_DDHRESULT D3DERR_TEXTURE_DESTROY_FAILED,		722
MAKE_DDHRESULT D3DERR_TEXTURE_LOCK_FAILED,		723
MAKE_DDHRESULT D3DERR_TEXTURE_UNLOCK_FAILED,		724
MAKE_DDHRESULT D3DERR_TEXTURE_LOAD_FAILED,		725
MAKE_DDHRESULT D3DERR_TEXTURE_SWAP_FAILED,		726
MAKE_DDHRESULT D3DERR_TEXTURE_LOCKED,			727
MAKE_DDHRESULT D3DERR_TEXTURE_NOT_LOCKED,		728
MAKE_DDHRESULT D3DERR_TEXTURE_GETSURF_FAILED,		729
MAKE_DDHRESULT D3DERR_MATRIX_CREATE_FAILED,		730
MAKE_DDHRESULT D3DERR_MATRIX_DESTROY_FAILED,		731
MAKE_DDHRESULT D3DERR_MATRIX_SETDATA_FAILED,		732
MAKE_DDHRESULT D3DERR_MATRIX_GETDATA_FAILED,		733
MAKE_DDHRESULT D3DERR_SETVIEWPORTDATA_FAILED,		734
MAKE_DDHRESULT D3DERR_INVALIDCURRENTVIEWPORT,		735
MAKE_DDHRESULT D3DERR_INVALIDPRIMITIVETYPE,		736
MAKE_DDHRESULT D3DERR_INVALIDVERTEXTYPE,		737
MAKE_DDHRESULT D3DERR_TEXTURE_BADSIZE,			738
MAKE_DDHRESULT D3DERR_INVALIDRAMPTEXTURE,		739
MAKE_DDHRESULT D3DERR_MATERIAL_CREATE_FAILED,		740
MAKE_DDHRESULT D3DERR_MATERIAL_DESTROY_FAILED,		741
MAKE_DDHRESULT D3DERR_MATERIAL_SETDATA_FAILED,		742
MAKE_DDHRESULT D3DERR_MATERIAL_GETDATA_FAILED,		743
MAKE_DDHRESULT D3DERR_INVALIDPALETTE,			744
MAKE_DDHRESULT D3DERR_ZBUFF_NEEDS_SYSTEMMEMORY, 	745
MAKE_DDHRESULT D3DERR_ZBUFF_NEEDS_VIDEOMEMORY,		746
MAKE_DDHRESULT D3DERR_SURFACENOTINVIDMEM,		747
MAKE_DDHRESULT D3DERR_LIGHT_SET_FAILED, 		750
MAKE_DDHRESULT D3DERR_LIGHTHASVIEWPORT, 		751
MAKE_DDHRESULT D3DERR_LIGHTNOTINTHISVIEWPORT,		752
MAKE_DDHRESULT D3DERR_SCENE_IN_SCENE,			760
MAKE_DDHRESULT D3DERR_SCENE_NOT_IN_SCENE,		761
MAKE_DDHRESULT D3DERR_SCENE_BEGIN_FAILED,		762
MAKE_DDHRESULT D3DERR_SCENE_END_FAILED, 		763
MAKE_DDHRESULT D3DERR_INBEGIN,				770
MAKE_DDHRESULT D3DERR_NOTINBEGIN,			771
MAKE_DDHRESULT D3DERR_NOVIEWPORTS,			772
MAKE_DDHRESULT D3DERR_VIEWPORTDATANOTSET,		773
MAKE_DDHRESULT D3DERR_VIEWPORTHASNODEVICE,		774
MAKE_DDHRESULT D3DERR_NOCURRENTVIEWPORT,		775
MAKE_DDHRESULT D3DERR_INVALIDVERTEXFORMAT,		2048
MAKE_DDHRESULT D3DERR_COLORKEYATTACHED, 		2050
MAKE_DDHRESULT D3DERR_VERTEXBUFFEROPTIMIZED,		2060
MAKE_DDHRESULT D3DERR_VBUF_CREATE_FAILED,		2061
MAKE_DDHRESULT D3DERR_VERTEXBUFFERLOCKED,		2062
MAKE_DDHRESULT D3DERR_VERTEXBUFFERUNLOCKFAILED, 	2063
MAKE_DDHRESULT D3DERR_ZBUFFER_NOTPRESENT,		2070
MAKE_DDHRESULT D3DERR_STENCILBUFFER_NOTPRESENT, 	2071

MAKE_DDHRESULT D3DERR_WRONGTEXTUREFORMAT,		2072
MAKE_DDHRESULT D3DERR_UNSUPPORTEDCOLOROPERATION,	2073
MAKE_DDHRESULT D3DERR_UNSUPPORTEDCOLORARG,		2074
MAKE_DDHRESULT D3DERR_UNSUPPORTEDALPHAOPERATION,	2075
MAKE_DDHRESULT D3DERR_UNSUPPORTEDALPHAARG,		2076
MAKE_DDHRESULT D3DERR_TOOMANYOPERATIONS,		2077
MAKE_DDHRESULT D3DERR_CONFLICTINGTEXTUREFILTER, 	2078
MAKE_DDHRESULT D3DERR_UNSUPPORTEDFACTORVALUE,		2079
MAKE_DDHRESULT D3DERR_CONFLICTINGRENDERSTATE,		2081
MAKE_DDHRESULT D3DERR_UNSUPPORTEDTEXTUREFILTER, 	2082
MAKE_DDHRESULT D3DERR_TOOMANYPRIMITIVES,		2083
MAKE_DDHRESULT D3DERR_INVALIDMATRIX,			2084
MAKE_DDHRESULT D3DERR_TOOMANYVERTICES,			2085
MAKE_DDHRESULT D3DERR_CONFLICTINGTEXTUREPALETTE,	2086

MAKE_DDHRESULT D3DERR_INVALIDSTATEBLOCK,		2100
MAKE_DDHRESULT D3DERR_INBEGINSTATEBLOCK,		2101
MAKE_DDHRESULT D3DERR_NOTINBEGINSTATEBLOCK,		2102



; D3D Types

; #define D3DVALP(val, prec)    ((float)(val))
; #define D3DVAL(val)           ((float)(val))
; #define D3DDivide(a, b)       (float)((double) (a) / (double) (b))
; #define D3DMultiply(a, b)     ((a) * (b))


D3DENUMRET_CANCEL					equ		DDENUMRET_CANCEL
D3DENUMRET_OK						equ		DDENUMRET_OK


D3DMAXUSERCLIPPLANES					equ		32

D3DCLIPPLANE0						equ		1	; (1 << 0)
D3DCLIPPLANE1						equ		2	; (1 << 1)
D3DCLIPPLANE2						equ		4	; (1 << 2)
D3DCLIPPLANE3						equ		8	; (1 << 3)
D3DCLIPPLANE4						equ		16	; (1 << 4)
D3DCLIPPLANE5						equ		32	; (1 << 5)

D3DCLIP_LEFT						equ		0x00000001
D3DCLIP_RIGHT						equ		0x00000002
D3DCLIP_TOP						equ		0x00000004
D3DCLIP_BOTTOM						equ		0x00000008
D3DCLIP_FRONT						equ		0x00000010
D3DCLIP_BACK						equ		0x00000020
D3DCLIP_GEN0						equ		0x00000040
D3DCLIP_GEN1						equ		0x00000080
D3DCLIP_GEN2						equ		0x00000100
D3DCLIP_GEN3						equ		0x00000200
D3DCLIP_GEN4						equ		0x00000400
D3DCLIP_GEN5						equ		0x00000800

D3DSTATUS_CLIPUNIONLEFT 				equ		D3DCLIP_LEFT
D3DSTATUS_CLIPUNIONRIGHT				equ		D3DCLIP_RIGHT
D3DSTATUS_CLIPUNIONTOP					equ		D3DCLIP_TOP
D3DSTATUS_CLIPUNIONBOTTOM				equ		D3DCLIP_BOTTOM
D3DSTATUS_CLIPUNIONFRONT				equ		D3DCLIP_FRONT
D3DSTATUS_CLIPUNIONBACK 				equ		D3DCLIP_BACK
D3DSTATUS_CLIPUNIONGEN0 				equ		D3DCLIP_GEN0
D3DSTATUS_CLIPUNIONGEN1 				equ		D3DCLIP_GEN1
D3DSTATUS_CLIPUNIONGEN2 				equ		D3DCLIP_GEN2
D3DSTATUS_CLIPUNIONGEN3 				equ		D3DCLIP_GEN3
D3DSTATUS_CLIPUNIONGEN4 				equ		D3DCLIP_GEN4
D3DSTATUS_CLIPUNIONGEN5 				equ		D3DCLIP_GEN5

D3DSTATUS_CLIPINTERSECTIONLEFT				equ		0x00001000
D3DSTATUS_CLIPINTERSECTIONRIGHT 			equ		0x00002000
D3DSTATUS_CLIPINTERSECTIONTOP				equ		0x00004000
D3DSTATUS_CLIPINTERSECTIONBOTTOM			equ		0x00008000
D3DSTATUS_CLIPINTERSECTIONFRONT 			equ		0x00010000
D3DSTATUS_CLIPINTERSECTIONBACK				equ		0x00020000
D3DSTATUS_CLIPINTERSECTIONGEN0				equ		0x00040000
D3DSTATUS_CLIPINTERSECTIONGEN1				equ		0x00080000
D3DSTATUS_CLIPINTERSECTIONGEN2				equ		0x00100000
D3DSTATUS_CLIPINTERSECTIONGEN3				equ		0x00200000
D3DSTATUS_CLIPINTERSECTIONGEN4				equ		0x00400000
D3DSTATUS_CLIPINTERSECTIONGEN5				equ		0x00800000
D3DSTATUS_ZNOTVISIBLE					equ		0x01000000

D3DSTATUS_CLIPUNIONALL		equ	(D3DSTATUS_CLIPUNIONLEFT+D3DSTATUS_CLIPUNIONRIGHT+D3DSTATUS_CLIPUNIONTOP+\
					 D3DSTATUS_CLIPUNIONBOTTOM+D3DSTATUS_CLIPUNIONFRONT+D3DSTATUS_CLIPUNIONBACK+\
					 D3DSTATUS_CLIPUNIONGEN0+D3DSTATUS_CLIPUNIONGEN1+D3DSTATUS_CLIPUNIONGEN2+\
					 D3DSTATUS_CLIPUNIONGEN3+D3DSTATUS_CLIPUNIONGEN4+D3DSTATUS_CLIPUNIONGEN5)
D3DSTATUS_CLIPINTERSECTIONALL	equ	(D3DSTATUS_CLIPINTERSECTIONLEFT+D3DSTATUS_CLIPINTERSECTIONRIGHT+\
					 D3DSTATUS_CLIPINTERSECTIONTOP+D3DSTATUS_CLIPINTERSECTIONBOTTOM+\
					 D3DSTATUS_CLIPINTERSECTIONFRONT+D3DSTATUS_CLIPINTERSECTIONBACK+\
					 D3DSTATUS_CLIPINTERSECTIONGEN0+D3DSTATUS_CLIPINTERSECTIONGEN1+\
					 D3DSTATUS_CLIPINTERSECTIONGEN2+D3DSTATUS_CLIPINTERSECTIONGEN3+\
					 D3DSTATUS_CLIPINTERSECTIONGEN4+D3DSTATUS_CLIPINTERSECTIONGEN5)
D3DSTATUS_DEFAULT		equ	(D3DSTATUS_CLIPINTERSECTIONALL+D3DSTATUS_ZNOTVISIBLE)

D3DTRANSFORM_CLIPPED					equ		0x00000001
D3DTRANSFORM_UNCLIPPED					equ		0x00000002




; enum D3DLIGHTTYPE
D3DLIGHT_POINT						equ		1
D3DLIGHT_SPOT						equ		2
D3DLIGHT_DIRECTIONAL					equ		3
D3DLIGHT_PARALLELPOINT					equ		4
D3DLIGHT_GLSPOT 					equ		5
D3DLIGHT_FORCE_DWORD					equ		0x7fffffff




D3DLIGHT_ACTIVE 					equ		0x00000001
D3DLIGHT_NO_SPECULAR					equ		0x00000002
D3DLIGHT_ALL						equ		(D3DLIGHT_ACTIVE+D3DLIGHT_NO_SPECULAR)

; #define D3DLIGHT_RANGE_MAX            ((float)sqrt(FLT_MAX))


D3DCOLOR_MONO						equ		1
D3DCOLOR_RGB						equ		2




D3DCLEAR_TARGET 					equ		0x00000001
D3DCLEAR_ZBUFFER					equ		0x00000002
D3DCLEAR_STENCIL					equ		0x00000004

; enum D3DOPCODE
D3DOP_POINT						equ		1
D3DOP_LINE						equ		2
D3DOP_TRIANGLE						equ		3
D3DOP_MATRIXLOAD					equ		4
D3DOP_MATRIXMULTIPLY					equ		5
D3DOP_STATETRANSFORM					equ		6
D3DOP_STATELIGHT					equ		7
D3DOP_STATERENDER					equ		8
D3DOP_PROCESSVERTICES					equ		9
D3DOP_TEXTURELOAD					equ		10
D3DOP_EXIT						equ		11
D3DOP_BRANCHFORWARD					equ		12
D3DOP_SPAN						equ		13
D3DOP_SETSTATUS 					equ		14

D3DOP_FORCE_DWORD					equ		0x7fffffff




; enum D3DSHADEMODE
D3DSHADE_FLAT						equ		1
D3DSHADE_GOURAUD					equ		2
D3DSHADE_PHONG						equ		3
D3DSHADE_FORCE_DWORD					equ		0x7fffffff


; enum D3DFILLMODE
D3DFILL_POINT						equ		1
D3DFILL_WIREFRAME					equ		2
D3DFILL_SOLID						equ		3
D3DFILL_FORCE_DWORD					equ		0x7fffffff




; enum D3DTEXTUREFILTER
D3DFILTER_NEAREST					equ		1
D3DFILTER_LINEAR					equ		2
D3DFILTER_MIPNEAREST					equ		3
D3DFILTER_MIPLINEAR					equ		4
D3DFILTER_LINEARMIPNEAREST				equ		5
D3DFILTER_LINEARMIPLINEAR				equ		6
D3DFILTER_FORCE_DWORD					equ		0x7fffffff


; enum D3DBLEND
D3DBLEND_ZERO						equ		1
D3DBLEND_ONE						equ		2
D3DBLEND_SRCCOLOR					equ		3
D3DBLEND_INVSRCCOLOR					equ		4
D3DBLEND_SRCALPHA					equ		5
D3DBLEND_INVSRCALPHA					equ		6
D3DBLEND_DESTALPHA					equ		7
D3DBLEND_INVDESTALPHA					equ		8
D3DBLEND_DESTCOLOR					equ		9
D3DBLEND_INVDESTCOLOR					equ		10
D3DBLEND_SRCALPHASAT					equ		11
D3DBLEND_BOTHSRCALPHA					equ		12
D3DBLEND_BOTHINVSRCALPHA				equ		13
D3DBLEND_FORCE_DWORD					equ		0x7fffffff


; enum D3DTEXTUREBLEND
D3DTBLEND_DECAL 					equ		1
D3DTBLEND_MODULATE					equ		2
D3DTBLEND_DECALALPHA					equ		3
D3DTBLEND_MODULATEALPHA 				equ		4
D3DTBLEND_DECALMASK					equ		5
D3DTBLEND_MODULATEMASK					equ		6
D3DTBLEND_COPY						equ		7
D3DTBLEND_ADD						equ		8
D3DTBLEND_FORCE_DWORD					equ		0x7fffffff


; enum D3DTEXTUREADDRESS
D3DTADDRESS_WRAP					equ		1
D3DTADDRESS_MIRROR					equ		2
D3DTADDRESS_CLAMP					equ		3
D3DTADDRESS_BORDER					equ		4
D3DTADDRESS_FORCE_DWORD 				equ		0x7fffffff


; enum D3DCULL
D3DCULL_NONE						equ		1
D3DCULL_CW						equ		2
D3DCULL_CCW						equ		3
D3DCULL_FORCE_DWORD					equ		0x7fffffff


; enum D3DCMPFUNC
D3DCMP_NEVER						equ		1
D3DCMP_LESS						equ		2
D3DCMP_EQUAL						equ		3
D3DCMP_LESSEQUAL					equ		4
D3DCMP_GREATER						equ		5
D3DCMP_NOTEQUAL 					equ		6
D3DCMP_GREATEREQUAL					equ		7
D3DCMP_ALWAYS						equ		8
D3DCMP_FORCE_DWORD					equ		0x7fffffff


; enum D3DSTENCILOP
D3DSTENCILOP_KEEP					equ		1
D3DSTENCILOP_ZERO					equ		2
D3DSTENCILOP_REPLACE					equ		3
D3DSTENCILOP_INCRSAT					equ		4
D3DSTENCILOP_DECRSAT					equ		5
D3DSTENCILOP_INVERT					equ		6
D3DSTENCILOP_INCR					equ		7
D3DSTENCILOP_DECR					equ		8
D3DSTENCILOP_FORCE_DWORD				equ		0x7fffffff


; enum D3DFOGMODE
D3DFOG_NONE						equ		0
D3DFOG_EXP						equ		1
D3DFOG_EXP2						equ		2
D3DFOG_LINEAR						equ		3
D3DFOG_FORCE_DWORD					equ		0x7fffffff


; enum D3DZBUFFERTYPE
D3DZB_FALSE						equ		0
D3DZB_TRUE						equ		1
D3DZB_USEW						equ		2
D3DZB_FORCE_DWORD					equ		0x7fffffff


; enum D3DANTIALIASMODE
D3DANTIALIAS_NONE					equ		0
D3DANTIALIAS_SORTDEPENDENT				equ		1
D3DANTIALIAS_SORTINDEPENDENT				equ		2
D3DANTIALIAS_FORCE_DWORD				equ		0x7fffffff


; enum D3DVERTEXTYPE
D3DVT_VERTEX						equ		1
D3DVT_LVERTEX						equ		2
D3DVT_TLVERTEX						equ		3
D3DVT_FORCE_DWORD					equ		0x7fffffff


; enum D3DPRIMITIVETYPE
D3DPT_POINTLIST 					equ		1
D3DPT_LINELIST						equ		2
D3DPT_LINESTRIP 					equ		3
D3DPT_TRIANGLELIST					equ		4
D3DPT_TRIANGLESTRIP					equ		5
D3DPT_TRIANGLEFAN					equ		6
D3DPT_FORCE_DWORD					equ		0x7fffffff


D3DSTATE_OVERRIDE_BIAS					equ		256

; #define D3DSTATE_OVERRIDE(type) (D3DRENDERSTATETYPE)(((DWORD) (type) + D3DSTATE_OVERRIDE_BIAS))

; enum D3DTRANSFORMSTATETYPE
D3DTRANSFORMSTATE_WORLD 				equ		1
D3DTRANSFORMSTATE_VIEW					equ		2
D3DTRANSFORMSTATE_PROJECTION				equ		3
D3DTRANSFORMSTATE_WORLD1				equ		4
D3DTRANSFORMSTATE_WORLD2				equ		5
D3DTRANSFORMSTATE_WORLD3				equ		6
D3DTRANSFORMSTATE_TEXTURE0				equ		16
D3DTRANSFORMSTATE_TEXTURE1				equ		17
D3DTRANSFORMSTATE_TEXTURE2				equ		18
D3DTRANSFORMSTATE_TEXTURE3				equ		19
D3DTRANSFORMSTATE_TEXTURE4				equ		20
D3DTRANSFORMSTATE_TEXTURE5				equ		21
D3DTRANSFORMSTATE_TEXTURE6				equ		22
D3DTRANSFORMSTATE_TEXTURE7				equ		23
D3DTRANSFORMSTATE_FORCE_DWORD				equ		0x7fffffff


; enum D3DLIGHTSTATETYPE
D3DLIGHTSTATE_MATERIAL					equ		1
D3DLIGHTSTATE_AMBIENT					equ		2
D3DLIGHTSTATE_COLORMODEL				equ		3
D3DLIGHTSTATE_FOGMODE					equ		4
D3DLIGHTSTATE_FOGSTART					equ		5
D3DLIGHTSTATE_FOGEND					equ		6
D3DLIGHTSTATE_FOGDENSITY				equ		7
D3DLIGHTSTATE_COLORVERTEX				equ		8
D3DLIGHTSTATE_FORCE_DWORD				equ		0x7fffffff


; enum D3DRENDERSTATETYPE
D3DRENDERSTATE_TEXTUREHANDLE				equ		1
D3DRENDERSTATE_ANTIALIAS				equ		2
D3DRENDERSTATE_TEXTUREADDRESS				equ		3
D3DRENDERSTATE_TEXTUREPERSPECTIVE			equ		4
D3DRENDERSTATE_WRAPU					equ		5
D3DRENDERSTATE_WRAPV					equ		6
D3DRENDERSTATE_ZENABLE					equ		7
D3DRENDERSTATE_FILLMODE 				equ		8
D3DRENDERSTATE_SHADEMODE				equ		9
D3DRENDERSTATE_LINEPATTERN				equ		10
D3DRENDERSTATE_MONOENABLE				equ		11
D3DRENDERSTATE_ROP2					equ		12
D3DRENDERSTATE_PLANEMASK				equ		13
D3DRENDERSTATE_ZWRITEENABLE				equ		14
D3DRENDERSTATE_ALPHATESTENABLE				equ		15
D3DRENDERSTATE_LASTPIXEL				equ		16
D3DRENDERSTATE_TEXTUREMAG				equ		17
D3DRENDERSTATE_TEXTUREMIN				equ		18
D3DRENDERSTATE_SRCBLEND 				equ		19
D3DRENDERSTATE_DESTBLEND				equ		20
D3DRENDERSTATE_TEXTUREMAPBLEND				equ		21
D3DRENDERSTATE_CULLMODE 				equ		22
D3DRENDERSTATE_ZFUNC					equ		23
D3DRENDERSTATE_ALPHAREF 				equ		24
D3DRENDERSTATE_ALPHAFUNC				equ		25
D3DRENDERSTATE_DITHERENABLE				equ		26
D3DRENDERSTATE_ALPHABLENDENABLE 			equ		27
D3DRENDERSTATE_FOGENABLE				equ		28
D3DRENDERSTATE_SPECULARENABLE				equ		29
D3DRENDERSTATE_ZVISIBLE 				equ		30
D3DRENDERSTATE_SUBPIXEL 				equ		31
D3DRENDERSTATE_SUBPIXELX				equ		32
D3DRENDERSTATE_STIPPLEDALPHA				equ		33
D3DRENDERSTATE_FOGCOLOR 				equ		34
D3DRENDERSTATE_FOGTABLEMODE				equ		35
D3DRENDERSTATE_FOGTABLESTART				equ		36
D3DRENDERSTATE_FOGTABLEEND				equ		37
D3DRENDERSTATE_FOGTABLEDENSITY				equ		38
D3DRENDERSTATE_FOGSTART 				equ		36
D3DRENDERSTATE_FOGEND					equ		37
D3DRENDERSTATE_FOGDENSITY				equ		38
D3DRENDERSTATE_STIPPLEENABLE				equ		39
D3DRENDERSTATE_EDGEANTIALIAS				equ		40
D3DRENDERSTATE_COLORKEYENABLE				equ		41
D3DRENDERSTATE_BORDERCOLOR				equ		43
D3DRENDERSTATE_TEXTUREADDRESSU				equ		44
D3DRENDERSTATE_TEXTUREADDRESSV				equ		45
D3DRENDERSTATE_MIPMAPLODBIAS				equ		46
D3DRENDERSTATE_ZBIAS					equ		47
D3DRENDERSTATE_RANGEFOGENABLE				equ		48
D3DRENDERSTATE_ANISOTROPY				equ		49
D3DRENDERSTATE_FLUSHBATCH				equ		50
D3DRENDERSTATE_TRANSLUCENTSORTINDEPENDENT		equ		51

D3DRENDERSTATE_STENCILENABLE				equ		52
D3DRENDERSTATE_STENCILFAIL				equ		53
D3DRENDERSTATE_STENCILZFAIL				equ		54
D3DRENDERSTATE_STENCILPASS				equ		55
D3DRENDERSTATE_STENCILFUNC				equ		56
D3DRENDERSTATE_STENCILREF				equ		57
D3DRENDERSTATE_STENCILMASK				equ		58
D3DRENDERSTATE_STENCILWRITEMASK 			equ		59
D3DRENDERSTATE_TEXTUREFACTOR				equ		60

D3DRENDERSTATE_STIPPLEPATTERN00 			equ		64
D3DRENDERSTATE_STIPPLEPATTERN01 			equ		65
D3DRENDERSTATE_STIPPLEPATTERN02 			equ		66
D3DRENDERSTATE_STIPPLEPATTERN03 			equ		67
D3DRENDERSTATE_STIPPLEPATTERN04 			equ		68
D3DRENDERSTATE_STIPPLEPATTERN05 			equ		69
D3DRENDERSTATE_STIPPLEPATTERN06 			equ		70
D3DRENDERSTATE_STIPPLEPATTERN07 			equ		71
D3DRENDERSTATE_STIPPLEPATTERN08 			equ		72
D3DRENDERSTATE_STIPPLEPATTERN09 			equ		73
D3DRENDERSTATE_STIPPLEPATTERN10 			equ		74
D3DRENDERSTATE_STIPPLEPATTERN11 			equ		75
D3DRENDERSTATE_STIPPLEPATTERN12 			equ		76
D3DRENDERSTATE_STIPPLEPATTERN13 			equ		77
D3DRENDERSTATE_STIPPLEPATTERN14 			equ		78
D3DRENDERSTATE_STIPPLEPATTERN15 			equ		79
D3DRENDERSTATE_STIPPLEPATTERN16 			equ		80
D3DRENDERSTATE_STIPPLEPATTERN17 			equ		81
D3DRENDERSTATE_STIPPLEPATTERN18 			equ		82
D3DRENDERSTATE_STIPPLEPATTERN19 			equ		83
D3DRENDERSTATE_STIPPLEPATTERN20 			equ		84
D3DRENDERSTATE_STIPPLEPATTERN21 			equ		85
D3DRENDERSTATE_STIPPLEPATTERN22 			equ		86
D3DRENDERSTATE_STIPPLEPATTERN23 			equ		87
D3DRENDERSTATE_STIPPLEPATTERN24 			equ		88
D3DRENDERSTATE_STIPPLEPATTERN25 			equ		89
D3DRENDERSTATE_STIPPLEPATTERN26 			equ		90
D3DRENDERSTATE_STIPPLEPATTERN27 			equ		91
D3DRENDERSTATE_STIPPLEPATTERN28 			equ		92
D3DRENDERSTATE_STIPPLEPATTERN29 			equ		93
D3DRENDERSTATE_STIPPLEPATTERN30 			equ		94
D3DRENDERSTATE_STIPPLEPATTERN31 			equ		95

D3DRENDERSTATE_WRAP0					equ		128
D3DRENDERSTATE_WRAP1					equ		129
D3DRENDERSTATE_WRAP2					equ		130
D3DRENDERSTATE_WRAP3					equ		131
D3DRENDERSTATE_WRAP4					equ		132
D3DRENDERSTATE_WRAP5					equ		133
D3DRENDERSTATE_WRAP6					equ		134
D3DRENDERSTATE_WRAP7					equ		135
D3DRENDERSTATE_CLIPPING 				equ		136
D3DRENDERSTATE_LIGHTING 				equ		137
D3DRENDERSTATE_EXTENTS					equ		138
D3DRENDERSTATE_AMBIENT					equ		139
D3DRENDERSTATE_FOGVERTEXMODE				equ		140
D3DRENDERSTATE_COLORVERTEX				equ		141
D3DRENDERSTATE_LOCALVIEWER				equ		142
D3DRENDERSTATE_NORMALIZENORMALS 			equ		143
D3DRENDERSTATE_COLORKEYBLENDENABLE			equ		144
D3DRENDERSTATE_DIFFUSEMATERIALSOURCE			equ		145
D3DRENDERSTATE_SPECULARMATERIALSOURCE			equ		146
D3DRENDERSTATE_AMBIENTMATERIALSOURCE			equ		147
D3DRENDERSTATE_EMISSIVEMATERIALSOURCE			equ		148
D3DRENDERSTATE_VERTEXBLEND				equ		151
D3DRENDERSTATE_CLIPPLANEENABLE				equ		152

D3DRENDERSTATE_FORCE_DWORD				equ		0x7fffffff


; enum D3DMATERIALCOLORSOURCE
D3DMCS_MATERIAL 					equ		0
D3DMCS_COLOR1						equ		1
D3DMCS_COLOR2						equ		2
D3DMCS_FORCE_DWORD					equ		0x7fffffff


D3DRENDERSTATE_BLENDENABLE				equ		D3DRENDERSTATE_ALPHABLENDENABLE
D3DRENDERSTATE_WRAPBIAS 				equ		128UL
D3DWRAP_U						equ		0x00000001L
D3DWRAP_V						equ		0x00000002L

D3DWRAPCOORD_0						equ		0x00000001L
D3DWRAPCOORD_1						equ		0x00000002L
D3DWRAPCOORD_2						equ		0x00000004L
D3DWRAPCOORD_3						equ		0x00000008L

; #define D3DRENDERSTATE_STIPPLEPATTERN(y) (D3DRENDERSTATE_STIPPLEPATTERN00 + (y))



D3DPROCESSVERTICES_TRANSFORMLIGHT			equ		0x00000000L
D3DPROCESSVERTICES_TRANSFORM				equ		0x00000001L
D3DPROCESSVERTICES_COPY 				equ		0x00000002L
D3DPROCESSVERTICES_OPMASK				equ		0x00000007L

D3DPROCESSVERTICES_UPDATEEXTENTS			equ		0x00000008L
D3DPROCESSVERTICES_NOCOLOR				equ		0x00000010L

; enum D3DTEXTURESTAGESTATETYPE
D3DTSS_COLOROP						equ		1
D3DTSS_COLORARG1					equ		2
D3DTSS_COLORARG2					equ		3
D3DTSS_ALPHAOP						equ		4
D3DTSS_ALPHAARG1					equ		5
D3DTSS_ALPHAARG2					equ		6
D3DTSS_BUMPENVMAT00					equ		7
D3DTSS_BUMPENVMAT01					equ		8
D3DTSS_BUMPENVMAT10					equ		9
D3DTSS_BUMPENVMAT11					equ		10
D3DTSS_TEXCOORDINDEX					equ		11
D3DTSS_ADDRESS						equ		12
D3DTSS_ADDRESSU 					equ		13
D3DTSS_ADDRESSV 					equ		14
D3DTSS_BORDERCOLOR					equ		15
D3DTSS_MAGFILTER					equ		16
D3DTSS_MINFILTER					equ		17
D3DTSS_MIPFILTER					equ		18
D3DTSS_MIPMAPLODBIAS					equ		19
D3DTSS_MAXMIPLEVEL					equ		20
D3DTSS_MAXANISOTROPY					equ		21
D3DTSS_BUMPENVLSCALE					equ		22
D3DTSS_BUMPENVLOFFSET					equ		23
D3DTSS_TEXTURETRANSFORMFLAGS				equ		24
D3DTSS_FORCE_DWORD					equ		0x7fffffff


D3DTSS_TCI_PASSTHRU					equ		0x00000000
D3DTSS_TCI_CAMERASPACENORMAL				equ		0x00010000
D3DTSS_TCI_CAMERASPACEPOSITION				equ		0x00020000
D3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR			equ		0x00030000

; enum D3DTEXTUREOP
D3DTOP_DISABLE						equ		1
D3DTOP_SELECTARG1					equ		2
D3DTOP_SELECTARG2					equ		3

D3DTOP_MODULATE 					equ		4
D3DTOP_MODULATE2X					equ		5
D3DTOP_MODULATE4X					equ		6

D3DTOP_ADD						equ		7
D3DTOP_ADDSIGNED					equ		8
D3DTOP_ADDSIGNED2X					equ		9
D3DTOP_SUBTRACT 					equ		10
D3DTOP_ADDSMOOTH					equ		11

D3DTOP_BLENDDIFFUSEALPHA				equ		12
D3DTOP_BLENDTEXTUREALPHA				equ		13
D3DTOP_BLENDFACTORALPHA 				equ		14
D3DTOP_BLENDTEXTUREALPHAPM				equ		15
D3DTOP_BLENDCURRENTALPHA				equ		16

D3DTOP_PREMODULATE					equ		17
D3DTOP_MODULATEALPHA_ADDCOLOR				equ		18
D3DTOP_MODULATECOLOR_ADDALPHA				equ		19
D3DTOP_MODULATEINVALPHA_ADDCOLOR			equ		20
D3DTOP_MODULATEINVCOLOR_ADDALPHA			equ		21

D3DTOP_BUMPENVMAP					equ		22
D3DTOP_BUMPENVMAPLUMINANCE				equ		23
D3DTOP_DOTPRODUCT3					equ		24

D3DTOP_FORCE_DWORD					equ		0x7fffffff


D3DTA_SELECTMASK					equ		0x0000000f
D3DTA_DIFFUSE						equ		0x00000000
D3DTA_CURRENT						equ		0x00000001
D3DTA_TEXTURE						equ		0x00000002
D3DTA_TFACTOR						equ		0x00000003
D3DTA_SPECULAR						equ		0x00000004
D3DTA_COMPLEMENT					equ		0x00000010
D3DTA_ALPHAREPLICATE					equ		0x00000020

; enum D3DTEXTUREMAGFILTER
D3DTFG_POINT						equ		1
D3DTFG_LINEAR						equ		2
D3DTFG_FLATCUBIC					equ		3
D3DTFG_GAUSSIANCUBIC					equ		4
D3DTFG_ANISOTROPIC					equ		5
D3DTFG_FORCE_DWORD					equ		0x7fffffff


; enum D3DTEXTUREMINFILTER
D3DTFN_POINT						equ		1
D3DTFN_LINEAR						equ		2
D3DTFN_ANISOTROPIC					equ		3
D3DTFN_FORCE_DWORD					equ		0x7fffffff


; enum D3DTEXTUREMIPFILTER
D3DTFP_NONE						equ		1
D3DTFP_POINT						equ		2
D3DTFP_LINEAR						equ		3
D3DTFP_FORCE_DWORD					equ		0x7fffffff


D3DTRIFLAG_START					equ		0x00000000L
; #define D3DTRIFLAG_STARTFLAT(len) (len)
D3DTRIFLAG_ODD						equ		0x0000001eL
D3DTRIFLAG_EVEN 					equ		0x0000001fL

D3DTRIFLAG_EDGEENABLE1					equ		0x00000100L
D3DTRIFLAG_EDGEENABLE2					equ		0x00000200L
D3DTRIFLAG_EDGEENABLE3					equ		0x00000400L

D3DTRIFLAG_EDGEENABLETRIANGLE		equ	(D3DTRIFLAG_EDGEENABLE1+D3DTRIFLAG_EDGEENABLE2+D3DTRIFLAG_EDGEENABLE3)



D3DSETSTATUS_STATUS					equ		0x00000001L
D3DSETSTATUS_EXTENTS					equ		0x00000002L
D3DSETSTATUS_ALL					equ		(D3DSETSTATUS_STATUS+D3DSETSTATUS_EXTENTS)



D3DCLIPSTATUS_STATUS					equ		0x00000001L
D3DCLIPSTATUS_EXTENTS2					equ		0x00000002L
D3DCLIPSTATUS_EXTENTS3					equ		0x00000004L



D3DEXECUTE_CLIPPED					equ		0x00000001l
D3DEXECUTE_UNCLIPPED					equ		0x00000002l



D3DPAL_FREE						equ		0x00
D3DPAL_READONLY 					equ		0x40
D3DPAL_RESERVED 					equ		0x80



D3DVBCAPS_SYSTEMMEMORY					equ		0x00000800l
D3DVBCAPS_WRITEONLY					equ		0x00010000l
D3DVBCAPS_OPTIMIZED					equ		0x80000000l
D3DVBCAPS_DONOTCLIP					equ		0x00000001l

D3DVOP_LIGHT						equ		1024   ; (1 << 10)
D3DVOP_TRANSFORM					equ		1      ; (1 << 0)
D3DVOP_CLIP						equ		4      ; (1 << 2)
D3DVOP_EXTENTS						equ		8      ; (1 << 3)

D3DMAXNUMVERTICES					equ		65535  ; ((1<<16) - 1)

D3DMAXNUMPRIMITIVES					equ		65535  ; ((1<<16) - 1)

D3DPV_DONOTCOPYDATA					equ		1      ; (1 << 0)

D3DFVF_RESERVED0					equ		0x001
D3DFVF_POSITION_MASK					equ		0x00E
D3DFVF_XYZ						equ		0x002
D3DFVF_XYZRHW						equ		0x004
D3DFVF_XYZB1						equ		0x006
D3DFVF_XYZB2						equ		0x008
D3DFVF_XYZB3						equ		0x00a
D3DFVF_XYZB4						equ		0x00c
D3DFVF_XYZB5						equ		0x00e

D3DFVF_NORMAL						equ		0x010
D3DFVF_RESERVED1					equ		0x020
D3DFVF_DIFFUSE						equ		0x040
D3DFVF_SPECULAR 					equ		0x080
D3DFVF_TEXCOUNT_MASK					equ		0xf00
D3DFVF_TEXCOUNT_SHIFT					equ		8
D3DFVF_TEX0						equ		0x000
D3DFVF_TEX1						equ		0x100
D3DFVF_TEX2						equ		0x200
D3DFVF_TEX3						equ		0x300
D3DFVF_TEX4						equ		0x400
D3DFVF_TEX5						equ		0x500
D3DFVF_TEX6						equ		0x600
D3DFVF_TEX7						equ		0x700
D3DFVF_TEX8						equ		0x800

D3DFVF_RESERVED2					equ		0xf000

D3DFVF_VERTEX		equ		(D3DFVF_XYZ+D3DFVF_NORMAL+D3DFVF_TEX1)
D3DFVF_LVERTEX		equ		(D3DFVF_XYZ+D3DFVF_RESERVED1+D3DFVF_DIFFUSE+D3DFVF_SPECULAR+D3DFVF_TEX1)
D3DFVF_TLVERTEX 	equ		(D3DFVF_XYZRHW+D3DFVF_DIFFUSE+D3DFVF_SPECULAR+D3DFVF_TEX1)



D3DDP_MAXTEXCOORD					equ		8



D3DVIS_INSIDE_FRUSTUM					equ		0
D3DVIS_INTERSECT_FRUSTUM				equ		1
D3DVIS_OUTSIDE_FRUSTUM					equ		2
D3DVIS_INSIDE_LEFT					equ		0
D3DVIS_INTERSECT_LEFT					equ		4	 ; (1 << 2)
D3DVIS_OUTSIDE_LEFT					equ		8	 ; (2 << 2)
D3DVIS_INSIDE_RIGHT					equ		0
D3DVIS_INTERSECT_RIGHT					equ		16	 ; (1 << 4)
D3DVIS_OUTSIDE_RIGHT					equ		32	 ; (2 << 4)
D3DVIS_INSIDE_TOP					equ		0
D3DVIS_INTERSECT_TOP					equ		64	 ; (1 << 6)
D3DVIS_OUTSIDE_TOP					equ		128	 ; (2 << 6)
D3DVIS_INSIDE_BOTTOM					equ		0
D3DVIS_INTERSECT_BOTTOM 				equ		256	 ; (1 << 8)
D3DVIS_OUTSIDE_BOTTOM					equ		512	 ; (2 << 8)
D3DVIS_INSIDE_NEAR					equ		0
D3DVIS_INTERSECT_NEAR					equ		1024	 ; (1 << 10)
D3DVIS_OUTSIDE_NEAR					equ		2048	 ; (2 << 10)
D3DVIS_INSIDE_FAR					equ		0
D3DVIS_INTERSECT_FAR					equ		4096	 ; (1 << 12)
D3DVIS_OUTSIDE_FAR					equ		8192	 ; (2 << 12)

D3DVIS_MASK_FRUSTUM					equ		3	 ; (3 << 0)
D3DVIS_MASK_LEFT					equ		12	 ; (3 << 2)
D3DVIS_MASK_RIGHT					equ		48	 ; (3 << 4)
D3DVIS_MASK_TOP 					equ		192	 ; (3 << 6)
D3DVIS_MASK_BOTTOM					equ		768	 ; (3 << 8)
D3DVIS_MASK_NEAR					equ		3072	 ; (3 << 10)
D3DVIS_MASK_FAR 					equ		12288	 ; (3 << 12)

D3DDEVINFOID_TEXTUREMANAGER				equ		1
D3DDEVINFOID_D3DTEXTUREMANAGER				equ		2
D3DDEVINFOID_TEXTURING					equ		3

; enum D3DSTATEBLOCKTYPE
D3DSBT_ALL						equ		1
D3DSBT_PIXELSTATE					equ		2
D3DSBT_VERTEXSTATE					equ		3
D3DSBT_FORCE_DWORD					equ		0xffffffff


; enum D3DVERTEXBLENDFLAGS
D3DVBLEND_DISABLE					equ		0
D3DVBLEND_1WEIGHT					equ		1
D3DVBLEND_2WEIGHTS					equ		2
D3DVBLEND_3WEIGHTS					equ		3


; enum D3DTEXTURETRANSFORMFLAGS
D3DTTFF_DISABLE 					equ		0
D3DTTFF_COUNT1						equ		1
D3DTTFF_COUNT2						equ		2
D3DTTFF_COUNT3						equ		3
D3DTTFF_COUNT4						equ		4
D3DTTFF_PROJECTED					equ		256
D3DTTFF_FORCE_DWORD					equ		0x7fffffff


D3DFVF_TEXTUREFORMAT2					equ		0
D3DFVF_TEXTUREFORMAT1					equ		3
D3DFVF_TEXTUREFORMAT3					equ		1
D3DFVF_TEXTUREFORMAT4					equ		2

; #define D3DFVF_TEXCOORDSIZE3(CoordIndex) (D3DFVF_TEXTUREFORMAT3 << (CoordIndex*2 + 16))
; #define D3DFVF_TEXCOORDSIZE2(CoordIndex) (D3DFVF_TEXTUREFORMAT2)
; #define D3DFVF_TEXCOORDSIZE4(CoordIndex) (D3DFVF_TEXTUREFORMAT4 << (CoordIndex*2 + 16))
; #define D3DFVF_TEXCOORDSIZE1(CoordIndex) (D3DFVF_TEXTUREFORMAT1 << (CoordIndex*2 + 16))




; Enums

D3DNEXT_NEXT						equ		0x01l
D3DNEXT_HEAD						equ		0x02l
D3DNEXT_TAIL						equ		0x04l

D3DDP_WAIT						equ		0x00000001l
D3DDP_OUTOFORDER					equ		0x00000002l
D3DDP_DONOTCLIP 					equ		0x00000004l
D3DDP_DONOTUPDATEEXTENTS				equ		0x00000008l
D3DDP_DONOTLIGHT					equ		0x00000010l


; Capabilities

D3DTRANSFORMCAPS_CLIP					equ		0x00000001L

D3DLIGHTINGMODEL_RGB					equ		0x00000001
D3DLIGHTINGMODEL_MONO					equ		0x00000002

D3DLIGHTCAPS_POINT					equ		0x00000001
D3DLIGHTCAPS_SPOT					equ		0x00000002
D3DLIGHTCAPS_DIRECTIONAL				equ		0x00000004
D3DLIGHTCAPS_PARALLELPOINT				equ		0x00000008
D3DLIGHTCAPS_GLSPOT					equ		0x00000010

D3DPMISCCAPS_MASKPLANES 				equ		0x00000001
D3DPMISCCAPS_MASKZ					equ		0x00000002
D3DPMISCCAPS_LINEPATTERNREP				equ		0x00000004
D3DPMISCCAPS_CONFORMANT 				equ		0x00000008
D3DPMISCCAPS_CULLNONE					equ		0x00000010
D3DPMISCCAPS_CULLCW					equ		0x00000020
D3DPMISCCAPS_CULLCCW					equ		0x00000040

D3DPRASTERCAPS_DITHER					equ		0x00000001
D3DPRASTERCAPS_ROP2					equ		0x00000002
D3DPRASTERCAPS_XOR					equ		0x00000004
D3DPRASTERCAPS_PAT					equ		0x00000008
D3DPRASTERCAPS_ZTEST					equ		0x00000010
D3DPRASTERCAPS_SUBPIXEL 				equ		0x00000020
D3DPRASTERCAPS_SUBPIXELX				equ		0x00000040
D3DPRASTERCAPS_FOGVERTEX				equ		0x00000080
D3DPRASTERCAPS_FOGTABLE 				equ		0x00000100
D3DPRASTERCAPS_STIPPLE					equ		0x00000200
D3DPRASTERCAPS_ANTIALIASSORTDEPENDENT			equ		0x00000400
D3DPRASTERCAPS_ANTIALIASSORTINDEPENDENT 		equ		0x00000800
D3DPRASTERCAPS_ANTIALIASEDGES				equ		0x00001000
D3DPRASTERCAPS_MIPMAPLODBIAS				equ		0x00002000
D3DPRASTERCAPS_ZBIAS					equ		0x00004000
D3DPRASTERCAPS_ZBUFFERLESSHSR				equ		0x00008000
D3DPRASTERCAPS_FOGRANGE 				equ		0x00010000
D3DPRASTERCAPS_ANISOTROPY				equ		0x00020000
D3DPRASTERCAPS_WBUFFER					equ		0x00040000
D3DPRASTERCAPS_TRANSLUCENTSORTINDEPENDENT		equ		0x00080000
D3DPRASTERCAPS_WFOG					equ		0x00100000
D3DPRASTERCAPS_ZFOG					equ		0x00200000

D3DPCMPCAPS_NEVER					equ		0x00000001
D3DPCMPCAPS_LESS					equ		0x00000002
D3DPCMPCAPS_EQUAL					equ		0x00000004
D3DPCMPCAPS_LESSEQUAL					equ		0x00000008
D3DPCMPCAPS_GREATER					equ		0x00000010
D3DPCMPCAPS_NOTEQUAL					equ		0x00000020
D3DPCMPCAPS_GREATEREQUAL				equ		0x00000040
D3DPCMPCAPS_ALWAYS					equ		0x00000080

D3DPBLENDCAPS_ZERO					equ		0x00000001
D3DPBLENDCAPS_ONE					equ		0x00000002
D3DPBLENDCAPS_SRCCOLOR					equ		0x00000004
D3DPBLENDCAPS_INVSRCCOLOR				equ		0x00000008
D3DPBLENDCAPS_SRCALPHA					equ		0x00000010
D3DPBLENDCAPS_INVSRCALPHA				equ		0x00000020
D3DPBLENDCAPS_DESTALPHA 				equ		0x00000040
D3DPBLENDCAPS_INVDESTALPHA				equ		0x00000080
D3DPBLENDCAPS_DESTCOLOR 				equ		0x00000100
D3DPBLENDCAPS_INVDESTCOLOR				equ		0x00000200
D3DPBLENDCAPS_SRCALPHASAT				equ		0x00000400
D3DPBLENDCAPS_BOTHSRCALPHA				equ		0x00000800
D3DPBLENDCAPS_BOTHINVSRCALPHA				equ		0x00001000

D3DPSHADECAPS_COLORFLATMONO				equ		0x00000001
D3DPSHADECAPS_COLORFLATRGB				equ		0x00000002
D3DPSHADECAPS_COLORGOURAUDMONO				equ		0x00000004
D3DPSHADECAPS_COLORGOURAUDRGB				equ		0x00000008
D3DPSHADECAPS_COLORPHONGMONO				equ		0x00000010
D3DPSHADECAPS_COLORPHONGRGB				equ		0x00000020

D3DPSHADECAPS_SPECULARFLATMONO				equ		0x00000040
D3DPSHADECAPS_SPECULARFLATRGB				equ		0x00000080
D3DPSHADECAPS_SPECULARGOURAUDMONO			equ		0x00000100
D3DPSHADECAPS_SPECULARGOURAUDRGB			equ		0x00000200
D3DPSHADECAPS_SPECULARPHONGMONO 			equ		0x00000400
D3DPSHADECAPS_SPECULARPHONGRGB				equ		0x00000800

D3DPSHADECAPS_ALPHAFLATBLEND				equ		0x00001000
D3DPSHADECAPS_ALPHAFLATSTIPPLED 			equ		0x00002000
D3DPSHADECAPS_ALPHAGOURAUDBLEND 			equ		0x00004000
D3DPSHADECAPS_ALPHAGOURAUDSTIPPLED			equ		0x00008000
D3DPSHADECAPS_ALPHAPHONGBLEND				equ		0x00010000
D3DPSHADECAPS_ALPHAPHONGSTIPPLED			equ		0x00020000

D3DPSHADECAPS_FOGFLAT					equ		0x00040000
D3DPSHADECAPS_FOGGOURAUD				equ		0x00080000
D3DPSHADECAPS_FOGPHONG					equ		0x00100000

D3DPTEXTURECAPS_PERSPECTIVE				equ		0x00000001
D3DPTEXTURECAPS_POW2					equ		0x00000002
D3DPTEXTURECAPS_ALPHA					equ		0x00000004
D3DPTEXTURECAPS_TRANSPARENCY				equ		0x00000008
D3DPTEXTURECAPS_BORDER					equ		0x00000010
D3DPTEXTURECAPS_SQUAREONLY				equ		0x00000020
D3DPTEXTURECAPS_TEXREPEATNOTSCALEDBYSIZE		equ		0x00000040
D3DPTEXTURECAPS_ALPHAPALETTE				equ		0x00000080
D3DPTEXTURECAPS_NONPOW2CONDITIONAL			equ		0x00000100L

D3DPTEXTURECAPS_PROJECTED				equ		0x00000400
D3DPTEXTURECAPS_CUBEMAP 				equ		0x00000800
D3DPTEXTURECAPS_COLORKEYBLEND				equ		0x00001000

D3DPTFILTERCAPS_NEAREST 				equ		0x00000001
D3DPTFILTERCAPS_LINEAR					equ		0x00000002
D3DPTFILTERCAPS_MIPNEAREST				equ		0x00000004
D3DPTFILTERCAPS_MIPLINEAR				equ		0x00000008
D3DPTFILTERCAPS_LINEARMIPNEAREST			equ		0x00000010
D3DPTFILTERCAPS_LINEARMIPLINEAR 			equ		0x00000020

D3DPTFILTERCAPS_MINFPOINT				equ		0x00000100
D3DPTFILTERCAPS_MINFLINEAR				equ		0x00000200
D3DPTFILTERCAPS_MINFANISOTROPIC 			equ		0x00000400

D3DPTFILTERCAPS_MIPFPOINT				equ		0x00010000
D3DPTFILTERCAPS_MIPFLINEAR				equ		0x00020000

D3DPTFILTERCAPS_MAGFPOINT				equ		0x01000000
D3DPTFILTERCAPS_MAGFLINEAR				equ		0x02000000
D3DPTFILTERCAPS_MAGFANISOTROPIC 			equ		0x04000000
D3DPTFILTERCAPS_MAGFAFLATCUBIC				equ		0x08000000
D3DPTFILTERCAPS_MAGFGAUSSIANCUBIC			equ		0x10000000

D3DPTBLENDCAPS_DECAL					equ		0x00000001
D3DPTBLENDCAPS_MODULATE 				equ		0x00000002
D3DPTBLENDCAPS_DECALALPHA				equ		0x00000004
D3DPTBLENDCAPS_MODULATEALPHA				equ		0x00000008
D3DPTBLENDCAPS_DECALMASK				equ		0x00000010
D3DPTBLENDCAPS_MODULATEMASK				equ		0x00000020
D3DPTBLENDCAPS_COPY					equ		0x00000040
D3DPTBLENDCAPS_ADD					equ		0x00000080

D3DPTADDRESSCAPS_WRAP					equ		0x00000001
D3DPTADDRESSCAPS_MIRROR 				equ		0x00000002
D3DPTADDRESSCAPS_CLAMP					equ		0x00000004
D3DPTADDRESSCAPS_BORDER 				equ		0x00000008
D3DPTADDRESSCAPS_INDEPENDENTUV				equ		0x00000010


D3DDEVICEDESCSIZE					equ		sizeof.D3DDEVICEDESC


D3DDEVICEDESC7SIZE					equ		sizeof.D3DDEVICEDESC7

D3DDD_COLORMODEL					equ		0x00000001
D3DDD_DEVCAPS						equ		0x00000002
D3DDD_TRANSFORMCAPS					equ		0x00000004
D3DDD_LIGHTINGCAPS					equ		0x00000008
D3DDD_BCLIPPING 					equ		0x00000010
D3DDD_LINECAPS						equ		0x00000020
D3DDD_TRICAPS						equ		0x00000040
D3DDD_DEVICERENDERBITDEPTH				equ		0x00000080
D3DDD_DEVICEZBUFFERBITDEPTH				equ		0x00000100
D3DDD_MAXBUFFERSIZE					equ		0x00000200
D3DDD_MAXVERTEXCOUNT					equ		0x00000400

D3DDEVCAPS_FLOATTLVERTEX				equ		0x00000001
D3DDEVCAPS_SORTINCREASINGZ				equ		0x00000002
D3DDEVCAPS_SORTDECREASINGZ				equ		0X00000004
D3DDEVCAPS_SORTEXACT					equ		0x00000008
D3DDEVCAPS_EXECUTESYSTEMMEMORY				equ		0x00000010
D3DDEVCAPS_EXECUTEVIDEOMEMORY				equ		0x00000020
D3DDEVCAPS_TLVERTEXSYSTEMMEMORY 			equ		0x00000040
D3DDEVCAPS_TLVERTEXVIDEOMEMORY				equ		0x00000080
D3DDEVCAPS_TEXTURESYSTEMMEMORY				equ		0x00000100
D3DDEVCAPS_TEXTUREVIDEOMEMORY				equ		0x00000200
D3DDEVCAPS_DRAWPRIMTLVERTEX				equ		0x00000400
D3DDEVCAPS_CANRENDERAFTERFLIP				equ		0x00000800
D3DDEVCAPS_TEXTURENONLOCALVIDMEM			equ		0x00001000
D3DDEVCAPS_DRAWPRIMITIVES2				equ		0x00002000
D3DDEVCAPS_SEPARATETEXTUREMEMORIES			equ		0x00004000
D3DDEVCAPS_DRAWPRIMITIVES2EX				equ		0x00008000
D3DDEVCAPS_HWTRANSFORMANDLIGHT				equ		0x00010000
D3DDEVCAPS_CANBLTSYSTONONLOCAL				equ		0x00020000
D3DDEVCAPS_HWRASTERIZATION				equ		0x00080000

D3DSTENCILCAPS_KEEP					equ		0x00000001
D3DSTENCILCAPS_ZERO					equ		0x00000002
D3DSTENCILCAPS_REPLACE					equ		0x00000004
D3DSTENCILCAPS_INCRSAT					equ		0x00000008
D3DSTENCILCAPS_DECRSAT					equ		0x00000010
D3DSTENCILCAPS_INVERT					equ		0x00000020
D3DSTENCILCAPS_INCR					equ		0x00000040
D3DSTENCILCAPS_DECR					equ		0x00000080

D3DTEXOPCAPS_DISABLE					equ		0x00000001
D3DTEXOPCAPS_SELECTARG1 				equ		0x00000002
D3DTEXOPCAPS_SELECTARG2 				equ		0x00000004
D3DTEXOPCAPS_MODULATE					equ		0x00000008
D3DTEXOPCAPS_MODULATE2X 				equ		0x00000010
D3DTEXOPCAPS_MODULATE4X 				equ		0x00000020
D3DTEXOPCAPS_ADD					equ		0x00000040
D3DTEXOPCAPS_ADDSIGNED					equ		0x00000080
D3DTEXOPCAPS_ADDSIGNED2X				equ		0x00000100
D3DTEXOPCAPS_SUBTRACT					equ		0x00000200
D3DTEXOPCAPS_ADDSMOOTH					equ		0x00000400
D3DTEXOPCAPS_BLENDDIFFUSEALPHA				equ		0x00000800
D3DTEXOPCAPS_BLENDTEXTUREALPHA				equ		0x00001000
D3DTEXOPCAPS_BLENDFACTORALPHA				equ		0x00002000
D3DTEXOPCAPS_BLENDTEXTUREALPHAPM			equ		0x00004000
D3DTEXOPCAPS_BLENDCURRENTALPHA				equ		0x00008000
D3DTEXOPCAPS_PREMODULATE				equ		0x00010000
D3DTEXOPCAPS_MODULATEALPHA_ADDCOLOR			equ		0x00020000
D3DTEXOPCAPS_MODULATECOLOR_ADDALPHA			equ		0x00040000
D3DTEXOPCAPS_MODULATEINVALPHA_ADDCOLOR			equ		0x00080000
D3DTEXOPCAPS_MODULATEINVCOLOR_ADDALPHA			equ		0x00100000
D3DTEXOPCAPS_BUMPENVMAP 				equ		0x00200000
D3DTEXOPCAPS_BUMPENVMAPLUMINANCE			equ		0x00400000
D3DTEXOPCAPS_DOTPRODUCT3				equ		0x00800000

D3DFVFCAPS_TEXCOORDCOUNTMASK				equ		0x0000FFFF
D3DFVFCAPS_DONOTSTRIPELEMENTS				equ		0x00080000

D3DVTXPCAPS_TEXGEN					equ		0x00000001
D3DVTXPCAPS_MATERIALSOURCE7				equ		0x00000002
D3DVTXPCAPS_VERTEXFOG					equ		0x00000004
D3DVTXPCAPS_DIRECTIONALLIGHTS				equ		0x00000008
D3DVTXPCAPS_POSITIONALLIGHTS				equ		0x00000010
D3DVTXPCAPS_LOCALVIEWER 				equ		0x00000020


D3DFDS_COLORMODEL					equ		0x00000001
D3DFDS_GUID						equ		0x00000002
D3DFDS_HARDWARE 					equ		0x00000004
D3DFDS_TRIANGLES					equ		0x00000008
D3DFDS_LINES						equ		0x00000010
D3DFDS_MISCCAPS 					equ		0x00000020
D3DFDS_RASTERCAPS					equ		0x00000040
D3DFDS_ZCMPCAPS 					equ		0x00000080
D3DFDS_ALPHACMPCAPS					equ		0x00000100
D3DFDS_SRCBLENDCAPS					equ		0x00000200
D3DFDS_DSTBLENDCAPS					equ		0x00000400
D3DFDS_SHADECAPS					equ		0x00000800
D3DFDS_TEXTURECAPS					equ		0x00001000
D3DFDS_TEXTUREFILTERCAPS				equ		0x00002000
D3DFDS_TEXTUREBLENDCAPS 				equ		0x00004000
D3DFDS_TEXTUREADDRESSCAPS				equ		0x00008000


D3DDEB_BUFSIZE						equ		0x00000001
D3DDEB_CAPS						equ		0x00000002
D3DDEB_LPDATA						equ		0x00000004

D3DDEBCAPS_SYSTEMMEMORY 				equ		0x00000001
D3DDEBCAPS_VIDEOMEMORY					equ		0x00000002
D3DDEBCAPS_MEM						equ		(D3DDEBCAPS_SYSTEMMEMORY+D3DDEBCAPS_VIDEOMEMORY)



; HAL types


D3DHAL_SCENE_CAPTURE_START				equ		0x00000000
D3DHAL_SCENE_CAPTURE_END				equ		0x00000001

D3DHALDP2_USERMEMVERTICES				equ		0x00000001
D3DHALDP2_EXECUTEBUFFER 				equ		0x00000002
D3DHALDP2_SWAPVERTEXBUFFER				equ		0x00000004
D3DHALDP2_SWAPCOMMANDBUFFER				equ		0x00000008
D3DHALDP2_REQVERTEXBUFSIZE				equ		0x00000010
D3DHALDP2_REQCOMMANDBUFSIZE				equ		0x00000020
D3DHALDP2_VIDMEMVERTEXBUF				equ		0x00000040
D3DHALDP2_VIDMEMCOMMANDBUF				equ		0x00000080

D3DTSS_TEXTUREMAP					equ		0

D3DHAL_SETLIGHT_ENABLE					equ		0
D3DHAL_SETLIGHT_DISABLE 				equ		1
D3DHAL_SETLIGHT_DATA					equ		2

D3DHAL_STATESETBEGIN					equ		0
D3DHAL_STATESETEND					equ		1
D3DHAL_STATESETDELETE					equ		2
D3DHAL_STATESETEXECUTE					equ		3
D3DHAL_STATESETCAPTURE					equ		4

; enum D3DHAL_DP2OPERATION
D3DDP2OP_POINTS 					equ		1
D3DDP2OP_INDEXEDLINELIST				equ		2
D3DDP2OP_INDEXEDTRIANGLELIST				equ		3
D3DDP2OP_RESERVED0					equ		4
D3DDP2OP_RENDERSTATE					equ		8
D3DDP2OP_LINELIST					equ		15
D3DDP2OP_LINESTRIP					equ		16
D3DDP2OP_INDEXEDLINESTRIP				equ		17
D3DDP2OP_TRIANGLELIST					equ		18
D3DDP2OP_TRIANGLESTRIP					equ		19
D3DDP2OP_INDEXEDTRIANGLESTRIP				equ		20
D3DDP2OP_TRIANGLEFAN					equ		21
D3DDP2OP_INDEXEDTRIANGLEFAN				equ		22
D3DDP2OP_TRIANGLEFAN_IMM				equ		23
D3DDP2OP_LINELIST_IMM					equ		24
D3DDP2OP_TEXTURESTAGESTATE				equ		25
D3DDP2OP_INDEXEDTRIANGLELIST2				equ		26
D3DDP2OP_INDEXEDLINELIST2				equ		27
D3DDP2OP_VIEWPORTINFO					equ		28
D3DDP2OP_WINFO						equ		29
; pre-DirectX 7 interfaces
D3DDP2OP_SETPALETTE					equ		30
D3DDP2OP_UPDATEPALETTE					equ		31
; DirectX 7 interfaces
D3DDP2OP_ZRANGE 					equ		32
D3DDP2OP_SETMATERIAL					equ		33
D3DDP2OP_SETLIGHT					equ		34
D3DDP2OP_CREATELIGHT					equ		35
D3DDP2OP_SETTRANSFORM					equ		36
D3DDP2OP_EXT						equ		37
D3DDP2OP_TEXBLT 					equ		38
D3DDP2OP_STATESET					equ		39
D3DDP2OP_SETPRIORITY					equ		40
; all interfaces
D3DDP2OP_SETRENDERTARGET				equ		41
D3DDP2OP_CLEAR						equ		42
; DirectX 7 interfaces
D3DDP2OP_SETTEXLOD					equ		43
D3DPP2OP_SETCLIPPLANE					equ		44




